Type.registerNamespace('Ee.UI.Xaml');

Ee.UI.Xaml.scriptVersion = "1.0.070606.0";

Ee.UI.Xaml.ScaleMode = function Ee$UI$Xaml$ScaleMode() {
    /// <field name="none" type="Number" integer="true" static="true"></field>
    /// <field name="zoom" type="Number" integer="true" static="true"></field>
    /// <field name="stretch" type="Number" integer="true" static="true"></field>
    if (arguments.length !== 0) throw Error.parameterCount();
    throw Error.notImplemented();
}




Ee.UI.Xaml.ScaleMode.prototype = {
    none: 0,
    zoom: 1,
    stretch: 2
}
Ee.UI.Xaml.ScaleMode.registerEnum('Ee.UI.Xaml.ScaleMode');
Ee.UI.Xaml.Control = function Ee$UI$Xaml$Control(domElement) {
    /// <param name="domElement" domElement="true"></param>
    var e = Function._validateParams(arguments, [
        {name: "domElement", domElement: true}
    ]);
    if (e) throw e;

    Ee.UI.Xaml.Control.initializeBase(this, [domElement]);
}







    function Ee$UI$Xaml$Control$add_xamlError(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler('xamlError', handler);
    }
    function Ee$UI$Xaml$Control$remove_xamlError(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler('xamlError', handler);
    }

    function Ee$UI$Xaml$Control$add_resize(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("resize", handler);
    }
    function Ee$UI$Xaml$Control$remove_resize(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("resize", handler);
    }

    function Ee$UI$Xaml$Control$add_xamlInitialized(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler('xamlInitialized', handler);
    }
    function Ee$UI$Xaml$Control$remove_xamlInitialized(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler('xamlInitialized', handler);
    }

    function Ee$UI$Xaml$Control$get_scaleMode() {
        /// <value type="Ee.UI.Xaml.ScaleMode"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._scaleMode;
    }
    function Ee$UI$Xaml$Control$set_scaleMode(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Ee.UI.Xaml.ScaleMode}]);
        if (e) throw e;

        this._scaleMode = value;
        if (this._xamlInitialized && value !== Ee.UI.Xaml.ScaleMode.none) {
            this._ensureTransform();
        }
    }


    function Ee$UI$Xaml$Control$get_xamlSource() {
        /// <value type="String"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._xamlSource || "";
    }
    function Ee$UI$Xaml$Control$set_xamlSource(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: String}]);
        if (e) throw e;

        if (this.get_isInitialized()) {
            throw Error.invalidOperation(Ee.UI.Xaml.Res.cannotChangeXamlSource);
        }
        this._xamlSource = value;
    }

    function Ee$UI$Xaml$Control$addEventListener(element, eventName, handler) {
        /// <param name="element"></param>
        /// <param name="eventName" type="String"></param>
        /// <param name="handler" type="Function"></param>
        /// <returns></returns>
        var e = Function._validateParams(arguments, [
            {name: "element"},
            {name: "eventName", type: String},
            {name: "handler", type: Function}
        ]);
        if (e) throw e;

        if (!this._boundEvents) {
            this._boundEvents = [];
        }

        var token = element.addEventListener(eventName, handler);
        this._boundEvents[this._boundEvents.length] = { element: element, eventName: eventName, token: token };
        return token;
    }

    function Ee$UI$Xaml$Control$addEventListeners(element, events, handlerOwner) {
        /// <param name="element"></param>
        /// <param name="events" type="Object"></param>
        /// <param name="handlerOwner" optional="true"></param>
        /// <returns></returns>
        var e = Function._validateParams(arguments, [
            {name: "element"},
            {name: "events", type: Object},
            {name: "handlerOwner", optional: true}
        ]);
        if (e) throw e;

        var tokens = { };
        for (var name in events) {
            var handler = events[name];
            if (typeof(handler) !== 'function') throw Error.invalidOperation(Sys.Res.cantAddNonFunctionhandler);
            if (handlerOwner) {
                handler = Function.createDelegate(handlerOwner, handler);
            }
            tokens[name] = this.addEventListener(element, name, handler);
        }
        return tokens;
    }

    function Ee$UI$Xaml$Control$dispose() {
        var host = this.get_element();
        if (host) {
            if (this._resizeDelegate) {
                host.content.onResize = null;
                this._resizeDelegate = null;
            }
            host.OnLoad = null;
            host.OnError = null;
        }

        if (this._xamlInitialized) {
            this.xamlDispose();
            this._xamlInitialized = false;
        }
        
        if (this._boundEvents) {
            for (var i = 0, l = this._boundEvents.length; i < l; i++) {
                var e = this._boundEvents[i];
                e.element.removeEventListener(e.eventName, e.token);
            }
            this._boundEvents = null;
        }

        Ee.UI.Xaml.Control.callBaseMethod(this, "dispose");
    }

    function Ee$UI$Xaml$Control$initialize() {
        Ee.UI.Xaml.Control.callBaseMethod(this, "initialize");

        var host = this.get_element();
        host.OnError = Function.createDelegate(this, this._xamlError);
        
        // set the xaml source
        var src = this.get_xamlSource();
        if (src && (typeof(host.Source) === 'undefined' || host.Source !== src)) {
            host.OnLoad = Function.createDelegate(this, this._xamlLoaded);
            host.Source = src;
        }
        else {
            // if we are not setting the source we assume its already been loaded by some other means
            this._raiseXamlInitialize();
        }
    }

    function Ee$UI$Xaml$Control$onResize(args) {
        /// <param name="args" type="Sys.EventArgs"></param>
        var e = Function._validateParams(arguments, [
            {name: "args", type: Sys.EventArgs}
        ]);
        if (e) throw e;

    }

    function Ee$UI$Xaml$Control$onXamlError(errorEventArgs) {
        /// <param name="errorEventArgs" type="Ee.UI.Xaml.ErrorEventArgs"></param>
        var e = Function._validateParams(arguments, [
            {name: "errorEventArgs", type: Ee.UI.Xaml.ErrorEventArgs}
        ]);
        if (e) throw e;

    }

    function Ee$UI$Xaml$Control$xamlDispose() {
        if (arguments.length !== 0) throw Error.parameterCount();
    }

    function Ee$UI$Xaml$Control$xamlInitialize() {
        if (arguments.length !== 0) throw Error.parameterCount();
    }

    function Ee$UI$Xaml$Control$_ensureTransform() {

        var root = this.get_element().content.root;
        var scalePlayer = Ee.UI.Xaml.Control._computeScale(root);
        var x, y;
        if (this.get_scaleMode() === Ee.UI.Xaml.ScaleMode.zoom) {
            // zoom
            x = y = Math.min(scalePlayer.horizontal, scalePlayer.vertical);
        }
        else {
            // fit
            x = scalePlayer.horizontal;
            y = scalePlayer.vertical;
        }
        Ee.UI.Xaml.Control._ensureScale(root, x, y);
        
        // ensure we are watching the resize event
        if (!this._resizeDelegate) {
            this._resizeDelegate = Function.createDelegate(this, this._onResize);
            root.getHost().content.onResize = this._resizeDelegate;
        }
    }

    function Ee$UI$Xaml$Control$_onResize() {
        var element = this.get_element();
        // DevDiv Bugs 125915: may have been disposed by now. SL calls us even though we unhook.
        if (element && (this.get_scaleMode() !== Ee.UI.Xaml.ScaleMode.none)) {
            this._ensureTransform();

            var args = Sys.EventArgs.Empty;
            this.onResize(args);
            var handler = this.get_events().getHandler("resize");
            if (handler) {
                handler(this, args);
            }
        }
    }

    function Ee$UI$Xaml$Control$_raiseXamlError(sender, errorEventArgs) {
        this.onXamlError(errorEventArgs);
        
        if (!errorEventArgs.get_cancel()) {
            var handler = this.get_events().getHandler("xamlError");
            if (handler) {
                handler(this, errorEventArgs);
            }
            // in debug mode, when error goes unhandled, throw exception
            // The silverlight error object is particular about what fields you can access depending on the type of the error.
            // Accessing an inappropriate field will cause an error.
            else {
                var xamlError = errorEventArgs.get_error(),
                    errorType = xamlError.errorType,
                    errorCode = xamlError.errorCode,
                    errorMessage = xamlError.errorMessage,
                    id = this.get_id(),
                    lineNumber = "", charPosition = "", xamlFile = "", methodName = "",
                    errorFormat = Ee.UI.Xaml.Res.otherError;
                // not all the elements are available for all error types (you get an exception if you try)
                if (errorType === "ParserError") {
                    errorFormat = Ee.UI.Xaml.Res.parserError;
                    lineNumber = xamlError.lineNumber;
                    charPosition = xamlError.charPosition;
                    xamlFile = xamlError.xamlFile;
                }
                else if ((errorType === "ImageError" || errorType === "MediaError") && errorMessage === "AG_E_NOT_FOUND") {
                        errorFormat = Ee.UI.Xaml.Res.mediaError_NotFound;
                        errorMessage = sender.Source;
                }
                else if (errorType === "RuntimeError") {
                    if (xamlError.lineNumber) {
                        errorFormat = Ee.UI.Xaml.Res.runtimeErrorWithPosition;
                        lineNumber = xamlError.lineNumber;
                        charPosition = xamlError.charPosition;
                        methodName = xamlError.methodName;
                    }
                    else {
                        errorFormat = Ee.UI.Xaml.Res.runtimeErrorWithoutPosition;
                        methodName = xamlError.methodName;
                    }
                }
                throw Error.invalidOperation(
                    String.format(errorFormat, id, errorType, errorCode, errorMessage, lineNumber, charPosition, methodName, xamlFile));
            }
        }
    }

    function Ee$UI$Xaml$Control$_raiseXamlInitialize() {
        if (this.get_scaleMode() !== Ee.UI.Xaml.ScaleMode.none) {
            this._ensureTransform();
        }
        this._xamlInitialized = true;
        this.xamlInitialize();
        var handler = this.get_events().getHandler('xamlInitialized');
        if (handler) {
            handler(this, Sys.EventArgs.Empty);
        }
    }

    function Ee$UI$Xaml$Control$_xamlError(sender, args) {
        var element = this.get_element();
        if (element) {
            // DevDiv Bugs 125915: may have been disposed by now. SL calls us even though we unhook.
            this._raiseXamlError(sender, new Ee.UI.Xaml.ErrorEventArgs(args));
        }
    }

    function Ee$UI$Xaml$Control$_xamlLoaded() {
        var element = this.get_element();
        if (element) {
            // DevDiv Bugs 125915: may have been disposed by now. SL calls us even though we unhook.
            element.OnLoad = null;
            this._raiseXamlInitialize();
        }
    }
Ee.UI.Xaml.Control.prototype = {
    _xamlSource: null,
    _xamlInitialized: false,
    _scaleMode: Ee.UI.Xaml.ScaleMode.none,
    _resizeDelegate: null,
    _boundEvents: null,
    
    add_xamlError: Ee$UI$Xaml$Control$add_xamlError,
    remove_xamlError: Ee$UI$Xaml$Control$remove_xamlError,

    add_resize: Ee$UI$Xaml$Control$add_resize,
    remove_resize: Ee$UI$Xaml$Control$remove_resize,

    add_xamlInitialized: Ee$UI$Xaml$Control$add_xamlInitialized,
    remove_xamlInitialized: Ee$UI$Xaml$Control$remove_xamlInitialized,

    get_scaleMode: Ee$UI$Xaml$Control$get_scaleMode,
    set_scaleMode: Ee$UI$Xaml$Control$set_scaleMode,
    
    
    get_xamlSource: Ee$UI$Xaml$Control$get_xamlSource,
    set_xamlSource: Ee$UI$Xaml$Control$set_xamlSource,
    
    addEventListener: Ee$UI$Xaml$Control$addEventListener,
    
    addEventListeners: Ee$UI$Xaml$Control$addEventListeners,
    
    dispose: Ee$UI$Xaml$Control$dispose,    
    
    initialize: Ee$UI$Xaml$Control$initialize,

    onResize: Ee$UI$Xaml$Control$onResize,
    
    onXamlError: Ee$UI$Xaml$Control$onXamlError,
    
    xamlDispose: Ee$UI$Xaml$Control$xamlDispose,

    xamlInitialize: Ee$UI$Xaml$Control$xamlInitialize,
    
    _ensureTransform: Ee$UI$Xaml$Control$_ensureTransform,

    _onResize: Ee$UI$Xaml$Control$_onResize,
    
    _raiseXamlError: Ee$UI$Xaml$Control$_raiseXamlError,
    
    _raiseXamlInitialize: Ee$UI$Xaml$Control$_raiseXamlInitialize,

    _xamlError: Ee$UI$Xaml$Control$_xamlError,
    
    _xamlLoaded: Ee$UI$Xaml$Control$_xamlLoaded
}

Ee.UI.Xaml.Control._computeScale = function Ee$UI$Xaml$Control$_computeScale(element) {
    // Calculates the scale of a xamlElement in relation to the Silverlight host.
    // used for autoScale and lockAspectRatio
    var width = element.width;
    var height = element.height;
    var host = element.getHost();
    var x = width ? (host.content.ActualWidth / width) : 0;
    var y = height ? (host.content.ActualHeight / height) : 0;
    return { horizontal: x, vertical: y };
}
Ee.UI.Xaml.Control._ensureScale = function Ee$UI$Xaml$Control$_ensureScale(el, x, y) {
    var transform = el.RenderTransform;
    if (!transform) {
        el.RenderTransform = transform = el.getHost().content.createFromXaml('<ScaleTransform ScaleX="1" ScaleY="1"/>');
    }
    else if (transform.toString() !== "ScaleTransform") {
        throw Error.invalidOperation(Ee.UI.Xaml.Res.scaleModeRequiresScaleTransform);
    }
    transform.ScaleX = x;
    transform.ScaleY = y;
}
Ee.UI.Xaml.Control._ensureMatrix = function Ee$UI$Xaml$Control$_ensureMatrix(el, xScale, yScale, xOffset, yOffset) {
    var transform = el.RenderTransform;
    if (!transform) {
        el.RenderTransform = transform = el.getHost().content.createFromXaml('<MatrixTransform Matrix="1.0,0.0, 0.0,1.0, 0.0,0.0"/>');
    }
    else if (transform.toString() !== "MatrixTransform") {
        throw Error.invalidOperation(Ee.UI.Xaml.Res.scaleModeRequiresScaleTransform); 
    }
    transform.Matrix.M11 = xScale;
    transform.Matrix.M22 = yScale;
    transform.Matrix.OffsetX = xOffset;
    transform.Matrix.OffsetY = yOffset;
}
Ee.UI.Xaml.Control.registerClass("Ee.UI.Xaml.Control", Sys.UI.Control);
Ee.UI.Xaml.ErrorEventArgs = function Ee$UI$Xaml$ErrorEventArgs(xamlError) {
    /// <param name="xamlError"></param>
    var e = Function._validateParams(arguments, [
        {name: "xamlError"}
    ]);
    if (e) throw e;

    this._xamlError = xamlError;
    Ee.UI.Xaml.ErrorEventArgs.initializeBase(this);
}



    function Ee$UI$Xaml$ErrorEventArgs$get_error() {
        /// <value></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._xamlError;
    }
Ee.UI.Xaml.ErrorEventArgs.prototype = {
    _xamlError: null,
    
    get_error: Ee$UI$Xaml$ErrorEventArgs$get_error
}
Ee.UI.Xaml.ErrorEventArgs.registerClass("Ee.UI.Xaml.ErrorEventArgs", Sys.CancelEventArgs);



Type.registerNamespace('Ee.UI.Xaml.Media');

Ee.UI.Xaml.Media.PlayerElementName  = {
    videoWindow             : "VideoWindow",              // the <mediaelement>
    placeholderImage        : "PlaceholderImage",         // Displays the placeholder image prior to the media loading
    playerControls          : "PlayerControls",           // area encompassing all player controls
    playButton              : "PlayButton",               // a play button
    playPauseButton         : "PlayPauseButton",          // a play/pause toggle button (requires PlaySymbol & PauseSymbol)
    playSymbol              : "PlaySymbol",               // part of play/pause button, represents symbol showing for "play"
    pauseSymbol             : "PauseSymbol",              // part of play/pause button, represents symbol showing for "pause"
    stopButton              : "StopButton",               // the stop button
    pauseButton             : "PauseButton",              // the pause button
    nextButton              : "NextButton",               // the next button (next chapter)
    previousButton          : "PreviousButton",           // the previous button (prev chapter)
    muteButton              : "MuteButton",               // mute button
    muteOnSymbol            : "MuteOnSymbol",             // adornment to show on MuteButton when audio muted
    muteOffSymbol           : "MuteOffSymbol",            // adornment to show on MuteButton when audio enabled
    timeSlider              : "TimeSlider",               // the scrub bar
    timeThumb               : "TimeThumb",                // the play head
    timeCompleted           : "TimeCompleted",            // indicator on slider showing how much time is completed
    volumeSlider            : "VolumeSlider",             // the volume slider bar
    volumeThumb             : "VolumeThumb",              // the volume slider thumb control
    volumeUpButton          : "VolumeUpButton",           // a button to make the volume increase
    volumeDownButton        : "VolumeDownButton",         // a button to make the volume decrease
    totalTimeText           : "TotalTimeText",            // the text area for total duration of video
    currentTimeText         : "CurrentTimeText",          // the text area for the current media time
    downloadSlider          : "DownloadProgressSlider",   // slider to show download progress
    downloadText            : "DownloadProgressText",     // text to show download progress
    bufferingArea           : "BufferingArea",            // canvas that contains buffering feedback UI
    bufferingText           : "BufferingText",            // text to show buffering progress
    fullScreenButton        : "FullScreenButton",         // button to show video full screen
    chapterArea             : "ChapterArea",              // encasing chapters area
    chapterToggleButton     : "ChapterToggleButton",      // toggles the chapter list
    chapterScroll           : "ChapterScroll",            // chapters scroll region
    chapterPrev             : "ChapterScrollPrevious",    // control to scroll chapters to next
    chapterNext             : "ChapterScrollNext",        // control to scroll chapters to previous
    chapterItem             : "ChapterScrollItem",        // item signifying video item
    captionText             : "CaptionText",              // TextBlock to show closed captions in    
    captionArea             : "CaptionArea",              // Background of CaptionText 
    captionToggleButton     : "CaptionToggleButton",      // Toggles closed captions
    captionOnSymbol         : "CaptionOnSymbol",          // adornment to show on CaptionButton when captions on
    captionOffSymbol        : "CaptionOffSymbol",         // adornment to show on CaptionButton when captions off
    fullScreenArea          : "FullScreenArea",           // enabled when player switches to FS
    fullScreenVideoWindow   : "FullScreenVideoWindow",    // video window used for fullscreen mode
    fullScreenCaptionText   : "FullScreenCaptionText",    // mirror of captions for fullscreen mode
    fullScreenCaptionArea   : "FullScreenCaptionArea"     // mirror of captions for fullscreen mode
};
Ee.UI.Xaml.Media._DomElement = function Ee$UI$Xaml$Media$_DomElement(host, nameElement) {
    // <summary>Represents a XAML Element</summary>
    // <param name="host">Silverlight host</param>
    // <param name="nameElement" type="String">Name of XAML canvas which represents the element</param>
    this._control = host.content.findName(nameElement);
    if (this._control) {
        this.bindEvent("mouseEnter", nameElement + "_MouseEnter");
        this.bindEvent("mouseLeave", nameElement + "_MouseLeave");
        this._showAnimation = this._control.findName(nameElement + "_Show");
        this._hideAnimation = this._control.findName(nameElement + "_Hide");
        this._enableAnimation = this._control.findName(nameElement + "_Enable");
        this._disableAnimation = this._control.findName(nameElement + "_Disable");
    }
}









    function Ee$UI$Xaml$Media$_DomElement$get_control() {
        if (arguments.length !== 0) throw Error.parameterCount();
        // <value>The underlying XAML control</value>
        return this._control;
    }

    function Ee$UI$Xaml$Media$_DomElement$get_enabled() {
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._enabled;
    }
    function Ee$UI$Xaml$Media$_DomElement$set_enabled(value) {
        if (value !== this.get_enabled()) {
            // e.g. might make the control look grayed out or increase its alpha
            var anim = value ? this._enableAnimation : this._disableAnimation;
            if (anim) anim.begin();
            this._enabled = value;
        }
    }

    function Ee$UI$Xaml$Media$_DomElement$bindEvent(eventName, animationName, callback, callbackOwner) {
        // helper that reduces code necessary to bind a xaml event to a function and have it play an animation by name
        // if set_enabled(false) is called, animations stop playing and callbacks aren't called. For example, a disabled button does nothing.
        if (animationName || callback) {
            var animation = null;
            if (animationName) animation = this._control.findName(animationName);
            
            // no animation found and theres no callback, no reason to hook the event
            if (!animation && !callback) return;
            
            if (!this._boundEvents) this._boundEvents = [];

            if (callback) {
                callback = Function.createDelegate(callbackOwner || this, callback);
            }
            
            var _this = this;
            function handleEvent(sender, args) {
                if (!_this.get_enabled()) return;
                if (callback && !callback(sender, args)) return;
                if (animation) animation.begin();
            }
            
            var token = this._control.addEventListener(eventName, handleEvent);
            this._boundEvents[this._boundEvents.length] = { eventName: eventName, token: token };
        }
    }

    function Ee$UI$Xaml$Media$_DomElement$dispose() {
        if (this._control) {
            if (this._boundEvents) {
                for (var i = 0, l = this._boundEvents.length; i < l; i++) {
                    var e = this._boundEvents[i];
                    this._control.removeEventListener(e.eventName, e.token);
                }
                this._boundEvents = null;
            }
                    
            this._showAnimation = null;
            this._hideAnimation = null;
            this._enableAnimation = null;
            this._disableAnimation = null;
            this._control = null;
        }
    }

    function Ee$UI$Xaml$Media$_DomElement$setVisible(value) {
        var anim = value ? this._showAnimation : this._hideAnimation;
        if (anim) {
            anim.begin();
        }
        else if (this._control) {
            this._control.visibility = value ? 0 : 1;
        }
    }
Ee.UI.Xaml.Media._DomElement.prototype = {
    _control: null,
    _boundEvents: null,
    _showAnimation: null,
    _hideAnimation: null,
    _enableAnimation: null,
    _disableAnimation: null,
    _enabled: true,
    
    get_control: Ee$UI$Xaml$Media$_DomElement$get_control,

    get_enabled: Ee$UI$Xaml$Media$_DomElement$get_enabled,
    set_enabled: Ee$UI$Xaml$Media$_DomElement$set_enabled,

    bindEvent: Ee$UI$Xaml$Media$_DomElement$bindEvent,
    
    dispose: Ee$UI$Xaml$Media$_DomElement$dispose,
    
    setVisible: Ee$UI$Xaml$Media$_DomElement$setVisible
}
Ee.UI.Xaml.Media._DomElement.registerClass('Ee.UI.Xaml.Media._DomElement', null, Sys.IDisposable);

Ee.UI.Xaml.Media._Button = function Ee$UI$Xaml$Media$_Button(host, nameElement, autoRepeatInterval,
                                            clickHandler, doubleClickHandler, handlerOwner, requiresSender) {
    
    Ee.UI.Xaml.Media._Button.initializeBase(this, [host, nameElement]);
    this._repeatInterval = autoRepeatInterval || 0;
    
    var control = this.get_control();
    if (control) {
        control.cursor = "Hand";
        this.bindEvent("mouseLeftButtonDown", nameElement + "_MouseDown", this._mouseDown);
        this.bindEvent("mouseLeftButtonUp", nameElement + "_MouseUp", this._mouseUp);
        this.bindEvent("mouseLeave", nameElement + "_MouseUp", this._mouseLeave);
    }
    if (handlerOwner) {
        // some button handlers are wired directly into public methods that dont take parameters.
        // others are private methods that need to know the button instance clicked.
        this._requiresSender = !!requiresSender;
        this._clickDelegate = Function.createDelegate(handlerOwner, clickHandler);
        if (doubleClickHandler) {
            this._doubleClickDelegate = Function.createDelegate(handlerOwner, doubleClickHandler);
        }
    }
}









    function Ee$UI$Xaml$Media$_Button$set_enabled(value) {
        Ee.UI.Xaml.Media._Button.callBaseMethod(this, "set_enabled", [value]);
        var c = this.get_control();
        if (c) c.cursor = value ? "Hand" : "Default";
    }

	function Ee$UI$Xaml$Media$_Button$dispose() {
	    this._cancelRepeat();
	    this._clickDelegate = null;
	    this._doubleClickDelegate = null;
        Ee.UI.Xaml.Media._Button.callBaseMethod(this, 'dispose');                
    }

    function Ee$UI$Xaml$Media$_Button$_cancelRepeat() {
        if (!this._repeatTimeout) return;
        window.clearTimeout(this._repeatTimeout);
        this._repeatTimeout = null;
        this._repeatClickDelegate = null;
    }

    function Ee$UI$Xaml$Media$_Button$_doClick(isDouble) {
        if (isDouble && this._doubleClickDelegate) {
            this._requiresSender ? this._doubleClickDelegate(this) : this._doubleClickDelegate();
        }
        else if (this._clickDelegate) {
            this._requiresSender ? this._clickDelegate(this) : this._clickDelegate();
        }
    }

    function Ee$UI$Xaml$Media$_Button$_mouseDown() {
        this._down = true;
        if (this._repeatInterval && !this._repeatTimeout) {
            // click immediately when it will be repeating,
            // otherwise we don't until leftbuttonup
            this._doClick(false);
            this._repeatClickDelegate = Function.createDelegate(this, this._repeatClick);
            this._repeatTimeout = window.setTimeout(this._repeatClickDelegate, this._repeatInterval);
        }
        return true;
    }

    function Ee$UI$Xaml$Media$_Button$_mouseLeave() {
        if (!this._down) {
            // we're not already down, so cancel the mouseup animation
            return false;
        }
        this._down = false;
        this._cancelRepeat();
        return true;
    }

    function Ee$UI$Xaml$Media$_Button$_mouseUp() {
        this._down = false;

        if (this._repeatTimeout) {
            this._cancelRepeat();
        }
        else {
            var tmNow = new Date().getTime();
            var last = this._timeLastLeftButtonUp;
            this._timeLastLeftButtonUp = tmNow;
            var doubleClick = last && ((tmNow - last) < 300);
            if (doubleClick) {
                // so a 3rd click won't result in another double click
                this._timeLastLeftButtonUp = 0;
            }
            this._doClick(doubleClick);
        }
        return true;
    }

    function Ee$UI$Xaml$Media$_Button$_repeatClick() {
        this._repeatTimeout = window.setTimeout(this._repeatClickDelegate, this._repeatInterval);
        this._doClick(false);
    }
Ee.UI.Xaml.Media._Button.prototype = {
    _down: false,
    _repeatInterval: 0,
    _repeatTimeout: null,
    _repeatClickDelegate: null,
    _timeLastLeftButtonUp: 0,
    _clickDelegate: null,
    _doubleClickDelegate: null,
    
    set_enabled: Ee$UI$Xaml$Media$_Button$set_enabled,
    
	dispose: Ee$UI$Xaml$Media$_Button$dispose,

    _cancelRepeat: Ee$UI$Xaml$Media$_Button$_cancelRepeat,

    _doClick: Ee$UI$Xaml$Media$_Button$_doClick,

    _mouseDown: Ee$UI$Xaml$Media$_Button$_mouseDown,
    
    _mouseLeave: Ee$UI$Xaml$Media$_Button$_mouseLeave,
    
    _mouseUp: Ee$UI$Xaml$Media$_Button$_mouseUp,

    _repeatClick: Ee$UI$Xaml$Media$_Button$_repeatClick
}
Ee.UI.Xaml.Media._Button.registerClass('Ee.UI.Xaml.Media._Button', Ee.UI.Xaml.Media._DomElement);

Ee.UI.Xaml.Media.Player = function Ee$UI$Xaml$Media$Player(domElement) {
    /// <param name="domElement"></param>
    var e = Function._validateParams(arguments, [
        {name: "domElement"}
    ]);
    if (e) throw e;

    Ee.UI.Xaml.Media.Player.initializeBase(this, [domElement]);
    // default scale mode for a media player
    this.set_scaleMode(Ee.UI.Xaml.ScaleMode.zoom);
}
















































    function Ee$UI$Xaml$Media$Player$add_chapterStarted(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("chapterStarted", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_chapterStarted(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("chapterStarted", handler);
    }

    function Ee$UI$Xaml$Media$Player$add_markerReached(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("markerReached", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_markerReached(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("markerReached", handler);
    }

    function Ee$UI$Xaml$Media$Player$add_mediaEnded(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("mediaEnded", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_mediaEnded(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("mediaEnded", handler);
    }

    function Ee$UI$Xaml$Media$Player$add_mediaFailed(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("mediaFailed", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_mediaFailed(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("mediaFailed", handler);
    }

    function Ee$UI$Xaml$Media$Player$add_mediaOpened(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("mediaOpened", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_mediaOpened(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("mediaOpened", handler);
    }

    function Ee$UI$Xaml$Media$Player$add_stateChanged(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("stateChanged", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_stateChanged(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("stateChanged", handler);
    }

    function Ee$UI$Xaml$Media$Player$add_volumeChanged(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().addHandler("volumeChanged", handler);
    }
    function Ee$UI$Xaml$Media$Player$remove_volumeChanged(handler) {
    var e = Function._validateParams(arguments, [{name: "handler", type: Function}]);
    if (e) throw e;

        this.get_events().removeHandler("volumeChanged", handler);
    }

    function Ee$UI$Xaml$Media$Player$get_autoPlay() {
        /// <value type="Boolean"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (this._mediaElement) return this._mediaElement.AutoPlay;
        if (this._autoPlay !== null) return this._autoPlay;
        return false;
    }
    function Ee$UI$Xaml$Media$Player$set_autoPlay(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Boolean}]);
        if (e) throw e;

        if (this._mediaElement) {
            this._mediaElement.AutoPlay = value;
        }
        else {
            this._autoPlay = value;
        }
    }

    function Ee$UI$Xaml$Media$Player$get_caption() {
        /// <value type="String"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._caption || "";
    }
    function Ee$UI$Xaml$Media$Player$set_caption(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: String}]);
        if (e) throw e;

        this._caption = value;
        if (this._captionArea) {
            this._captionArea.set_text(value);
        }
        if (this._captionAreaFS) {
            this._captionAreaFS.set_text(value);
        }
    }

    function Ee$UI$Xaml$Media$Player$get_chapters() {
        /// <value type="Array"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._chapters) return [];
        return Array.clone(this._chapters);
    }
    function Ee$UI$Xaml$Media$Player$set_chapters(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Array}]);
        if (e) throw e;

        this._chapters = value;
        if (this._chapterArea) {
            this._loadChapters(value);
        }
    }

    function Ee$UI$Xaml$Media$Player$get_currentChapter() {
        /// <value type="Number"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._currentChapter;
    }
    function Ee$UI$Xaml$Media$Player$set_currentChapter(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Number}]);
        if (e) throw e;

        var chapters = this.get_chapters();
        if (!chapters || value < 0 || value >= chapters.length) {
            throw Error.argumentOutOfRange("currentChapter", value, Ee.UI.Xaml.Media.Res.invalidChapterIndex);
        }
        var newTime = chapters[value].time;
        if (newTime !== -1) {
            this.set_timeIndex(newTime);
        }
    }

    function Ee$UI$Xaml$Media$Player$get_enableCaptions() {
        /// <value type="Boolean"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return !!this._enableCaptions;
    }
    function Ee$UI$Xaml$Media$Player$set_enableCaptions(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Boolean}]);
        if (e) throw e;

        if (this._enableCaptions !== value) {
            this._enableCaptions = value;
            this._ensureCaption();
        }
    }

    function Ee$UI$Xaml$Media$Player$get_mediaMarkers() {
        /// <value type="Array"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._mediaMarkers) return [];
        return Array.clone(this._mediaMarkers);
    }

    function Ee$UI$Xaml$Media$Player$get_mediaElement() {
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._mediaElement || null;
    }

    function Ee$UI$Xaml$Media$Player$get_mediaUrl() {
        /// <value type="String"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (this._mediaElement) return this._mediaElement.Source || "";
        return this._mediaUrl || "";
    }
    function Ee$UI$Xaml$Media$Player$set_mediaUrl(value) {    
        var e = Function._validateParams(arguments, [{name: "value", type: String}]);
        if (e) throw e;

        if (this._mediaElement) {
            this._loadPlaceholderImage();
            this._loadMediaUrl(value);
        }
        else {
            this._mediaUrl = value;
        }
    }

    function Ee$UI$Xaml$Media$Player$get_muted() {
        /// <value type="Boolean"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (this._mediaElement) return this._mediaElement.IsMuted;
        return !!this._muted;
    }
    function Ee$UI$Xaml$Media$Player$set_muted(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Boolean}]);
        if (e) throw e;

        if (value !== this.get_muted()) {
            if (this._mediaElement) {
                this._mediaElement.IsMuted = value;
                this._muteButton.set_state(value ? 1 : 0);
            }
            else {
                this._muted = value;
            }
            if (!this.get_isUpdating()) {
                this._raiseVolumeChanged(Sys.EventArgs.Empty);
            }
        }
    }

    function Ee$UI$Xaml$Media$Player$get_placeholderImage() {
        /// <value type="String" mayBeNull="true"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._placeholderImage || "";
    }
    function Ee$UI$Xaml$Media$Player$set_placeholderImage(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: String, mayBeNull: true}]);
        if (e) throw e;

        this._placeholderImage = value;
    }

    function Ee$UI$Xaml$Media$Player$get_playState() {
        /// <value type="String"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._mediaElement ? this._mediaElement.CurrentState : "Stopped";
    }

    function Ee$UI$Xaml$Media$Player$get_timeIndex() {
        /// <value type="Number"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._mediaElement ? this._mediaElement.position.seconds : 0;
    }
    function Ee$UI$Xaml$Media$Player$set_timeIndex(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Number}]);
        if (e) throw e;

        if(this._mediaElement && this._canSeek) {
            this._mediaEnded = false;
            this.set_caption("");
            // restrict to within 0 and naturalduration
            value = Math.max(0, value);
            value = Math.min(this._naturalduration, value);
            var position = this._mediaElement.position;
            position.seconds = value;
	        this._mediaElement.position = position;            
            // update ui and detect chapter changing
            this._updateTime(value);
            this._currentChapter = this._getChapterAt(value, true);
            this._detectChapterChanged();
        }
    }

    function Ee$UI$Xaml$Media$Player$get_volume() {
        /// <value type="Number"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (this._volume !== null) return this._volume;
        if (this._mediaElement) return this._mediaElement.volume;
        return Ee.UI.Xaml.Media.Player._defaultVolume;
    }
    function Ee$UI$Xaml$Media$Player$set_volume(value) {
        var e = Function._validateParams(arguments, [{name: "value", type: Number}]);
        if (e) throw e;

        if (value < 0 || value > 1) {
            throw Error.argumentOutOfRange("value", value, Ee.UI.Xaml.Media.Res.volumeRange);
        }
        if (value !== this.get_volume()) {
            if (this._mediaElement && this._mediaElement.CurrentState !== "Closed") {
                this._mediaElement.volume = value;
            }
            else {
                this._volume = value;
            }
            if (!this.get_isUpdating()) {
                this._raiseVolumeChanged(Sys.EventArgs.Empty);
            }
        }

        if (this._dragVolume) this._dragVolume.set_value(value);
    }

    function Ee$UI$Xaml$Media$Player$nextChapter() {
        /// <returns type="Boolean"></returns>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._canSeek) return false;
        var chapters = this.get_chapters();
        if (chapters) {
            var i = this.get_currentChapter();
            if (++i < chapters.length) {
                this.set_currentChapter(i);
                return true;
            }
        }
        return false;
    }

    function Ee$UI$Xaml$Media$Player$onChapterStarted(chapterEventArgs) {
        /// <param name="chapterEventArgs" type="Ee.UI.Xaml.Media.ChapterEventArgs"></param>
        var e = Function._validateParams(arguments, [
            {name: "chapterEventArgs", type: Ee.UI.Xaml.Media.ChapterEventArgs}
        ]);
        if (e) throw e;

    }

    function Ee$UI$Xaml$Media$Player$onMarkerReached(args) {
        /// <param name="args" type="Ee.UI.Xaml.Media.MarkerEventArgs"></param>
        var e = Function._validateParams(arguments, [
            {name: "args", type: Ee.UI.Xaml.Media.MarkerEventArgs}
        ]);
        if (e) throw e;

    }

    function Ee$UI$Xaml$Media$Player$onPlayStateChanged(stateChangedEventArgs) {
        /// <param name="stateChangedEventArgs" type="Ee.UI.Xaml.Media.StateChangedEventArgs"></param>
        var e = Function._validateParams(arguments, [
            {name: "stateChangedEventArgs", type: Ee.UI.Xaml.Media.StateChangedEventArgs}
        ]);
        if (e) throw e;

    }

    function Ee$UI$Xaml$Media$Player$onVolumeChanged(args) {
        /// <param name="args" type="Sys.EventArgs"></param>
        var e = Function._validateParams(arguments, [
            {name: "args", type: Sys.EventArgs}
        ]);
        if (e) throw e;

    }

    function Ee$UI$Xaml$Media$Player$pause() {
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._mediaElement) throw Error.invalidOperation(Ee.UI.Xaml.Media.Res.noMediaElement);
        if (!this._mediaOpened) return;
	    this._mediaElement.pause();
    }

    function Ee$UI$Xaml$Media$Player$play() {
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._mediaElement) throw Error.invalidOperation(Ee.UI.Xaml.Media.Res.noMediaElement);
        if (!this._mediaOpened) return;
        this.set_caption("");
        var me = this._mediaElement;
        if (this._mediaEnded) {
            this._mediaEnded = false;
            var seconds = me.Position.Seconds;
            var totalSeconds = me.NaturalDuration.Seconds;
            if ( seconds == totalSeconds )
            {
                me.Position = "0";
            }
        }
        me.play();
    }

    function Ee$UI$Xaml$Media$Player$previousChapter() {
        /// <returns type="Boolean"></returns>
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._canSeek) return false;
        var chapters = this.get_chapters();
        if (chapters) {
            var i = this.get_currentChapter();
            if (--i >= 0) {
                this.set_currentChapter(i);
                return true;
            }
        }
        return false;
    }

    function Ee$UI$Xaml$Media$Player$stop() {
        if (arguments.length !== 0) throw Error.parameterCount();
        if (!this._mediaElement) throw Error.invalidOperation(Ee.UI.Xaml.Media.Res.noMediaElement);
        if (!this._mediaOpened) return;
        this._mediaEnded = false;
        this._currentChapter = this._getChapterAt(0, true);
	    this._mediaElement.stop();
	    this.set_caption("");
    }

    function Ee$UI$Xaml$Media$Player$toggleMuted() {
        /// <returns type="Boolean"></returns>
        if (arguments.length !== 0) throw Error.parameterCount();
        var v = !this.get_muted();
        this.set_muted(v);
        return v;
    }

    function Ee$UI$Xaml$Media$Player$togglePlayPause() {
        /// <returns type="String"></returns>
        if (arguments.length !== 0) throw Error.parameterCount();
        this.get_playState() === "Playing" ? this.pause() : this.play();
        return this.get_playState();
    }

    function Ee$UI$Xaml$Media$Player$xamlDispose() {
        if (this._timerCookie) {
            window.clearTimeout(this._timerCookie);
            this._timerCookie = null;
        }
        if (this._domElements) {
            for (var i = 0, l = this._domElements.length; i < l; i++) {
                this._domElements[i].dispose();
            }
            delete this._domElements;
        }

        // player should not continue playing after disposed
        // safe to call stop in any state
        if (this._mediaElement) this._mediaElement.stop();
        // remove direct references to xaml elements
        this._mediaElement = null;
        this._bufferingText = null;
        this._bufferingStoryboard = null;
        
        var content = this.get_element() ? this.get_element().content : null;
        if (content) {
            content.onFullScreenChange = null;
        }
        
        Ee.UI.Xaml.Media.Player.callBaseMethod(this, "xamlDispose");        
    }

    function Ee$UI$Xaml$Media$Player$xamlInitialize() {
        // search and create controls for well named XAML elements
        this._bindChildControls(); 
        Ee.UI.Xaml.Media.Player.callBaseMethod(this, 'xamlInitialize');
        
        var chapters = this.get_chapters();
        if (chapters) {
            this._loadChapters(chapters);
        }
        
        if (this._mediaUrl === null) {
            // no initial media means you can't seek
            this._ensureSeeking(false);
            // disable play, pause, stop, etc
	        this._mediaAvailable(false);
	    }
        this._loadPlaceholderImage();	    
        this._clearMediaCache();
    }

    function Ee$UI$Xaml$Media$Player$_bindChildControls() {
        var names = Ee.UI.Xaml.Media.PlayerElementName,
            host = this.get_element(),
            btn = Ee.UI.Xaml.Media._Button,
            domEl = Ee.UI.Xaml.Media._DomElement,
            sldr = Ee.UI.Xaml.Media._Slider,
            mbtn = Ee.UI.Xaml.Media._MultiStateButton,
            tb = Ee.UI.Xaml.Media._TextBlock;
        
        var mediaDomElement;
        this._domElements = [
            mediaDomElement = new btn(host, names.videoWindow, null, this.togglePlayPause, this._onFullScreenME, this),
            this._fsCanvas = new btn(host, names.fullScreenArea, null, this.togglePlayPause, this._onFullScreenME, this),
            this._fsVideoWindow = new domEl(host, names.fullScreenVideoWindow),
            this._bufferingProgress = new domEl(host, names.bufferingArea),
            new domEl(host, names.playerControls),
            // buttons
            this._playButton = new btn(host, names.playButton, null, this.play, null, this),
            this._stopButton = new btn(host, names.stopButton, null, this.stop, null, this),
            this._pauseButton = new btn(host, names.pauseButton, null, this.pause, null, this),
            new btn(host, names.volumeUpButton, 20, this._onVolumeUp, null, this),
            new btn(host, names.volumeDownButton, 20, this._onVolumeDown, null, this),
            new btn(host, names.fullScreenButton, null, this._onFullScreen, null, this),
            this._previousButton = new btn(host, names.previousButton, null, this._chapterPrevious, null, this),
            this._nextButton = new btn(host, names.nextButton, null, this._chapterNext, null, this),
            this._playPauseButton = new mbtn(host, names.playPauseButton, null, this.togglePlayPause, null, this, names.playSymbol, names.pauseSymbol),
            this._muteButton = new mbtn(host, names.muteButton, null, this.toggleMuted, null, this, names.muteOffSymbol, names.muteOnSymbol),
            // time slider
            this._dragTime = new sldr(host, names.timeThumb, names.timeSlider, this._onTimeSliderChanged, this),
            // volume slider
            this._dragVolume = new sldr(host, names.volumeThumb, names.volumeSlider, this._onVolumeSliderChanged, this),
            // time
            this._totalTimeText = new tb(host, names.totalTimeText),
            this._currentTimeText = new tb(host, names.currentTimeText),
            this._downloadProgress = new Ee.UI.Xaml.Media._ProgressBar(host, names.downloadSlider, names.downloadText),
            // chapter area        
            this._chapterArea = new Ee.UI.Xaml.Media._ChapterArea(this),
            // caption area
            this._captionArea = new tb(host, names.captionText, names.captionArea),
            this._captionAreaFS = new tb(host, names.fullScreenCaptionText, names.fullScreenCaptionArea),
            // toggle captions on/off
            this._captionButton = new mbtn(host, names.captionToggleButton, null, this._onCaptionToggle, null, this, names.captionOnSymbol, names.captionOffSymbol),
            // placeholder image
            this._imageElement = new domEl(host, names.placeholderImage)
        ];

        mediaDomElement.bindEvent("mediaOpened", null, this._meMediaOpened, this);
        mediaDomElement.bindEvent("mediaFailed", null, this._meMediaFailed, this);
        mediaDomElement.bindEvent("mediaEnded", null, this._meMediaEnded, this);
        mediaDomElement.bindEvent("downloadProgressChanged", null, this._meDownloadProgress, this);
        mediaDomElement.bindEvent("bufferingProgressChanged", null, this._meBufferingProgress, this);
        mediaDomElement.bindEvent("markerReached", null, this._meMarkerReached, this);
        mediaDomElement.bindEvent("currentStateChanged", null, this._meStateChanged, this);

        // UI for buffering feedback        
        this._bufferingStoryboard = host.content.findName(names.bufferingArea + "_Buffering");
        this._bufferingText = host.content.findName(names.bufferingText);

        this._dragVolume.set_value(this.get_volume());

        // full screen event
        host.content.onFullScreenChange = Function.createDelegate(this, this._fullScreenChanged);
        
        this._mediaElement = mediaDomElement.get_control();
        if (!this._mediaElement) {
            throw Error.invalidOperation(Ee.UI.Xaml.Media.Res.noMediaElement);
        }
        this._mediaElement.AutoPlay = false;
    }

    function Ee$UI$Xaml$Media$Player$_chapterNext() {
        var chapters = this.get_chapters();
        if (!chapters || !chapters.length) {
            // if there are no chapters, the next and previous buttons jump by a percentage of play time
            this._skipTime(1);
        }
        else {
            this.nextChapter();
        }
    }

    function Ee$UI$Xaml$Media$Player$_chapterPrevious() {
        var chapters = this.get_chapters();
        if (!chapters || !chapters.length) {
            // if there are no chapters, the next and previous buttons jump by a percentage of play time
            this._skipTime(-1);
        }
        else {
            // find previous chapter (don't use previousChapter() because we need to allow 1s lead time)
            // e.g. clicking the previous chapter button in the middle of chapter #X should start at the beginning of chapter #X,
            // not chapter #X-1.
            // getChapterAt will tell us which chapter is playing at the current time minus 1 second
            var newChapter = this._getChapterAt(this.get_timeIndex() - 1);
            if (newChapter === -1) {
                // 1 second ago = before the first chapter in the list
                this.set_timeIndex(0);
            }
            else {
                this.set_currentChapter(newChapter);
            }
        }
    }

    function Ee$UI$Xaml$Media$Player$_clearMediaCache() {
        // some properties can't be set until the MediaElement has content
        if (this._muted !== null) {
            this._mediaElement.IsMuted = this._muted;
            this._muteButton.set_state(this._muted ? 1 : 0);
            this._muted = null;
        }
        if (this._volume !== null) {
            this._mediaElement.Volume = this._volume;
            this._dragVolume.set_value(this._volume);
            this._volume = null;
        }
        if (this._autoPlay !== null) {
            this._mediaElement.AutoPlay = this._autoPlay;
            this._autoPlay = null;
        }
        if (this._mediaUrl !== null) {
            this._loadMediaUrl(this._mediaUrl);
            this._mediaUrl = null
        }
    }

    function Ee$UI$Xaml$Media$Player$_detectChapterChanged(currentTime) {
        if (this._lastChapterStarted !== this._currentChapter) {
            // may have skipped into a chapter
            this._lastChapterStarted = this._currentChapter;
            this._raiseChapterStarted(new Ee.UI.Xaml.Media.ChapterEventArgs(this._currentChapter));
        }
        else {
            // We think we're on the same chapter we last raised an event for. But natural progression of the media
            // or seeking operations may have put the position outside the bounds of this chapter.
            
            // DevDiv Bugs 126619: use a 0.001 second padding to prevent false chapter start detection
            if ((this._nextChapterTime !== -1 && currentTime >= (this._nextChapterTime - 0.001)) ||
                (this._currentChapterTime !== -1 && currentTime < (this._currentChapterTime - 0.001))) {
                // the time index jumped outside the bounds of the current chapter
                this._currentChapter = this._getChapterAt(currentTime, true);
                this._lastChapterStarted = this._currentChapter;
                this._raiseChapterStarted(new Ee.UI.Xaml.Media.ChapterEventArgs(this._currentChapter));
            }
        }
    }

    function Ee$UI$Xaml$Media$Player$_enableBuffering(enabled, percent) {
        if (enabled) {
            if (this._bufferingText) {
                this._bufferingText.Visibility = 0;
                this._bufferingText.Text = percent.toString();
            }
            if (!this._bufferingProgressVisible) {
                this._bufferingProgress.setVisible(true);
                if (this._bufferingStoryboard) this._bufferingStoryboard.begin();
            }
            this._bufferingProgressVisible = true;
        }
        else if (this._bufferingProgressVisible) {
            if (this._bufferingText) {
                this._bufferingText.Visibility = 1;
            }
            this._bufferingProgress.setVisible(false);
            if (this._bufferingStoryboard) this._bufferingStoryboard.stop();
            this._bufferingProgressVisible = false;
        }
    }

    function Ee$UI$Xaml$Media$Player$_ensureCaption() {
        var showCaptions = this._toggledCaptions && this.get_enableCaptions();
        if (showCaptions) {
            var caption = this.get_caption();
            if (this._captionArea) {
                this._captionArea.set_text(caption);
            }
            if (this._captionAreaFS) {
                this._captionAreaFS.set_text(caption);
            }
        }
        else {
            if (this._captionArea) {
                this._captionArea.setVisible(false);
            }
            if (this._captionAreaFS) {
                this._captionAreaFS.setVisible(false);
            }
        }
    }

    function Ee$UI$Xaml$Media$Player$_ensureChapterArea() {
        var displayChapters = this._canSeek;
        if (displayChapters) {
            var chapters = this.get_chapters();
            if (chapters) {
                // we may have chapters but none have images. In that case don't show the chapter area.
                displayChapters = false;
                for (var i = 0, l = chapters.length; i < l; i++) {
                    if (chapters[i].imageUrl) {
                        displayChapters = true;
                        break;
                    }
                }
            }
        }
        
        if (displayChapters && !this._chaptersActive) {
            this._chapterArea.activate();
            this._chaptersActive = true;
        }
        else if(!displayChapters && this._chaptersActive) {
            this._chapterArea.deactivate();
            this._chapterArea.setVisible(false);
            this._chaptersActive = false;
        }
    }

    function Ee$UI$Xaml$Media$Player$_ensureSeeking(canSeek) {
        // when media is opened that doesn't support seeking (e.g. live streams), disable seek related controls
        if (this._canSeek !== canSeek) {
            this._canSeek = canSeek;
            this._previousButton.set_enabled(canSeek);
            this._nextButton.set_enabled(canSeek);
            this._ensureChapterArea();
            // it might be that the slider should still show time progress, but not allow you to click on it to set the time
            this._dragTime.set_enableSeeking(canSeek);
        }
    }

    function Ee$UI$Xaml$Media$Player$_ensureDuration(hasDuration) {
        if (this._hasDuration !== hasDuration) {
            this._hasDuration = hasDuration;
            this._totalTimeText.setVisible(hasDuration);
            this._currentTimeText.setVisible(hasDuration);
            // when there is no duration (e.g. live feed) the time slider is meaningless.
            this._dragTime.set_enabled(hasDuration);
        }
    }

    function Ee$UI$Xaml$Media$Player$_formatTime(time) {
    	var hours = Math.floor(time / (1000*60*60));
    	var minutes = Math.floor(time / (1000*60)) - (hours*60);
    	var seconds = Math.floor(time / 1000) - (hours*60*60) - (minutes*60);
	    var timeString = "";
    	if (hours > 0) {
    	    timeString = hours < 10 ? ("0" + hours) : ("" + hours);
    	    timeString += ":";
    	}
        timeString += minutes < 10 ? ("0" + minutes) : ("" + minutes);
	    timeString += ":";
        timeString += seconds < 10 ? ("0" + seconds) : ("" + seconds);
	    return timeString;
    }

    function Ee$UI$Xaml$Media$Player$_fullScreenChanged(sender, eventArgs) {
        var fs = this._fsCanvas.get_control();
        if (!fs) return;
        if (this.get_element().content.fullScreen) {
            var rootTransform = this.get_element().content.root.RenderTransform;
            var rootX = 1;
            var rootY = 1;
            if (rootTransform && rootTransform.toString() === "ScaleTransform") {
                rootX = rootTransform.ScaleX;
                rootY = rootTransform.ScaleY;
            }
            var s = Ee.UI.Xaml.Control._computeScale(fs);
            
            var newXScale = s.horizontal / rootX;
            var newYScale = s.vertical / rootY;
            
            Ee.UI.Xaml.Control._ensureScale(fs, newXScale, newYScale);
                        
            var fsVideoWindow = this._fsVideoWindow.get_control();                        
            if (fsVideoWindow)  {
                var minScale = Math.min(s.horizontal, s.vertical);
                var scale = Math.min(s.horizontal / rootX, s.vertical / rootY);
                var offX = (fs.getHost().content.ActualWidth-fsVideoWindow.width*minScale)/2;
                var offY = (fs.getHost().content.ActualHeight-fsVideoWindow.height*minScale)/2;
                if (newXScale>newYScale)
                    Ee.UI.Xaml.Control._ensureMatrix(fsVideoWindow, newYScale/newXScale, 1.0, offX/s.horizontal, offY/s.vertical);
                else
                    Ee.UI.Xaml.Control._ensureMatrix(fsVideoWindow, 1.0, newXScale/newYScale, offX/s.horizontal, offY/s.vertical);
            }
            fs.Visibility = 0;
        }
        else {
            fs.Visibility = 1;
        }
    }

    function Ee$UI$Xaml$Media$Player$_getChapterAt(seconds, isCurrentTime) {
        var chapters = this.get_chapters();
        var chapterIndex = -1;
        seconds += 0.001;
        if (chapters) {
            for (var i=0, l=chapters.length; i < l; i++) {
                // adjust the time 0.001, because actual chapter time is not as accurate as the time you specify.
                // If you specify a chapter to start at 5s, it might actually start at 4.999s or 5.001s, for example.
                // In other words you are considered at a chapter if you are at least within 0.001 seconds of it.
                var t = chapters[i].time - 0.001;
                if (t <= seconds) {
                    chapterIndex = i;
                }
                else {
                    break;
                }
            }
        }
        // if seconds is the current time index, we store the next chapter's start time so the timer
        // knows when to raise the chapter changed event while the video is naturally seeking forward.
        // otherwise we'd have to constantly index the chapter collection to see if the chapter changed.
        if (isCurrentTime) {
            this._currentChapterTime = (chapterIndex >= 0) ? chapters[chapterIndex].time : -1;
            this._nextChapterTime = (chapterIndex < chapters.length-1) ? chapters[chapterIndex+1].time : -1;
        }
        return chapterIndex;
    }

    function Ee$UI$Xaml$Media$Player$_getMediaFailedError() {
        var displayMessage = "Ee.UI.Xaml.Media.MediaFailedException: " +
            String.format(Ee.UI.Xaml.Media.Res.mediaFailed, this.get_mediaUrl());
        var e = Error.create(displayMessage, { name: "Ee.UI.Xaml.Media.MediaFailedException", mediaUrl: this.get_mediaUrl() });
        e.popStackFrame();
        return e;
    }

    function Ee$UI$Xaml$Media$Player$_loadChapters(chapters) {
        this._ensureChapterArea();
        this._chapterArea.setChapters(chapters);
        this._currentChapter = this._getChapterAt(this.get_timeIndex(), true);
        this._lastChapterStarted = -1;
        this._detectChapterChanged();
    }

    function Ee$UI$Xaml$Media$Player$_loadMediaUrl(url) {    
        this._currentChapter = -1;
        this._lastChapterStarted = -1;
        this._mediaElement.Source = url;
    }

    function Ee$UI$Xaml$Media$Player$_loadPlaceholderImage() {
        // show placeholder image over video
        var url = this.get_placeholderImage();
        if (url) {
            var img = this._imageElement.get_control();
            if (img) {
                img.Source = url;
                this._placeholderImageShowing = true;
                this._imageElement.setVisible(true);
            }
        }
    }

    function Ee$UI$Xaml$Media$Player$_onCaptionToggle() {
        this._toggledCaptions = !this._toggledCaptions;
        this._ensureCaption();
        this._captionButton.set_state(this._toggledCaptions ? 0 : 1);
    }

    function Ee$UI$Xaml$Media$Player$_onFullScreen() {
        var content = this.get_element().content;
        content.fullScreen = !content.fullScreen;
    }
    function Ee$UI$Xaml$Media$Player$_onFullScreenME() {
        // full screen request came from double clicking the media, which caused it to toggle play/pause
        // toggle once again to put back
        this.togglePlayPause();
        this._onFullScreen();
    }
    function Ee$UI$Xaml$Media$Player$_onTimeSliderChanged() {
        this.set_timeIndex(this._dragTime.get_value() * this._naturalduration);    
    }
    function Ee$UI$Xaml$Media$Player$_onVolumeDown() {
        this.set_volume(Math.max(0, this.get_volume() - 0.02));
    }
    function Ee$UI$Xaml$Media$Player$_onVolumeSliderChanged() {
        this.set_volume(this._dragVolume.get_value());
    }
    function Ee$UI$Xaml$Media$Player$_onVolumeUp() {
        this.set_volume(Math.min(1, this.get_volume() + 0.02));
    }

    function Ee$UI$Xaml$Media$Player$_mediaAvailable(available) {
        // when media is not available (e.g. it is closed or none was opened from the start), disable player controls
        if (this._mediaOpened !== available) {
            this._mediaOpened = available;
            this._playPauseButton.set_enabled(available);
            this._playButton.set_enabled(available);
            this._pauseButton.set_enabled(available);
            this._stopButton.set_enabled(available);
            if (!available) {
                this.set_caption("");
            }
        }
    }

    function Ee$UI$Xaml$Media$Player$_meBufferingProgress() {
        var progress = this._mediaElement.bufferingProgress;
        var percent = Math.round(progress * 100);
        if (percent >= 100) {
            this._enableBuffering(false);
        }
        else {
            this._enableBuffering(true, percent);
        }
    }

    function Ee$UI$Xaml$Media$Player$_meDownloadProgress() {
        // progressive download occuring, means there is no buffering. They don't occur at the same time.
        this._enableBuffering(false);
        this._downloadProgress.set_value(this._mediaElement.downloadProgress);
    }

    function Ee$UI$Xaml$Media$Player$_meMarkerReached(sender, args) {
        this._raiseMarkerReached(new Ee.UI.Xaml.Media.MarkerEventArgs(args.marker));
    }

    function Ee$UI$Xaml$Media$Player$_meMediaEnded() {
        this._mediaEnded = true;
        this._raiseEvent("mediaEnded", Sys.EventArgs.Empty);
    }

    function Ee$UI$Xaml$Media$Player$_meMediaFailed() {   
        this._naturalduration = null;
        this._enableBuffering(false);
        this._mediaAvailable(false);
        this._ensureDuration(false);
        this._ensureSeeking(false);
        this._mediaEnded = false;
        // existing captions should be cleared if the media fails to open
        this.set_caption("");
        
        var handler = this.get_events().getHandler('mediaFailed');
        if (handler) {
            handler(this, Sys.EventArgs.Empty);
        }
        else {
            throw this._getMediaFailedError();
        }   
    }

    function Ee$UI$Xaml$Media$Player$_meMediaOpened() {
        // note: this event may occur multiple times with a single mediaurl, if its an ASX stream with multiple entries.
        
        this._mediaEnded = false;
        // make sure properties set before hand are now copied in (e.g. Volume cant be set until media is loaded)
        this._clearMediaCache();
        // if a placeholder is showing, remove it
        if (this._placeholderImageShowing) {
            this._imageElement.setVisible(false);
            this._placeholderImageShowing = false;
        }
        // existing captions should be cleared if a new media file is opened
        this.set_caption("");
        
        // load markers in the head of the media
        this._markers = [];
        var markers = this._mediaElement.Markers;
        for (var i = 0, l = markers.Count; i < l; i++) {
            Array.add(this._markers, markers.getItem(i));
        }

        this._naturalduration = this._mediaElement.naturalduration.seconds;
        var hasDuration = !!this._naturalduration;
        var canSeek = hasDuration && this._mediaElement.CanSeek;
        if (canSeek) {
            // if seeking is supported, initialize chapter detection
            this._currentChapter = this._getChapterAt(0, true);
            this._lastChapterStarted = -1;
            this._detectChapterChanged();
	    }
	    if (hasDuration) {
            // and set the total/current time labels
            this._totalTimeText.set_text(this._formatTime(this._naturalduration * 1000));
            this._currentTimeText.set_text(this._formatTime(this.get_timeIndex() * 1000));
	    }
	    
	    // make sure player controls are in the right state
	    this._mediaAvailable(true);
	    this._ensureDuration(hasDuration);
	    this._ensureSeeking(canSeek);

        // hookup timer for monitoring time index (for chapter detection, time slider and currenttimetext updates)
        if (!this._timerCookie) {
            this._tickTimerDelegate = Function.createDelegate(this, this._tickTimer);
            this._timerCookie = window.setTimeout(this._tickTimerDelegate, 100);
        }
        this._raiseEvent("mediaOpened", Sys.EventArgs.Empty);
    }

    function Ee$UI$Xaml$Media$Player$_meStateChanged() {
        var newState = this.get_playState();
        if (newState === "Closed") {
            this._enableBuffering(false);
            this._mediaAvailable(false);
            this._ensureSeeking(false);
            this._mediaEnded = false;
        }
        else if (newState === "Playing" || newState === "Paused") {
            // playing/paused, make sure buffering area is hidden
            this._enableBuffering(false);
        }
        
        var oldState = this._oldState || "";
        if (newState !== oldState) {
            this._oldState = newState;
            this._raisePlayStateChanged(new Ee.UI.Xaml.Media.StateChangedEventArgs("playState", oldState, newState));
        }
    }

    function Ee$UI$Xaml$Media$Player$_raiseChapterStarted(chapterEventArgs) {
        this.onChapterStarted(chapterEventArgs);
        this._raiseEvent("chapterStarted", chapterEventArgs);
        this.raisePropertyChanged("currentChapter");
    }

    function Ee$UI$Xaml$Media$Player$_raiseEvent(name, args) {
        var handler = this.get_events().getHandler(name);
        if (handler) {
            handler(this, args);
        }
    }

    function Ee$UI$Xaml$Media$Player$_raiseMarkerReached(args) {
        if (this._toggledCaptions && this.get_enableCaptions()) {
            var marker = args.get_marker();
            var type = marker.type ? marker.type.toLowerCase() : "";
            if (type === "caption") {
                if (!this._enabledCaptionToggleButton) {
                    this._enabledCaptionToggleButton = true;
                    this._captionButton.setVisible(true);
                }
                var text = marker.text ? marker.text : "";
                if (text.trim().length === 0) {
                    text = "";
                }
                this.set_caption(text);
                this.raisePropertyChanged("caption");
            }
        }

        this.onMarkerReached(args);
        this._raiseEvent("markerReached", args);
    }

    function Ee$UI$Xaml$Media$Player$_raisePlayStateChanged(args) {
        this._playPauseButton.set_state(args.get_currentState() === "Playing" ? 1/*pause*/ : 0/*play*/);
        
        this.onPlayStateChanged(args);
        this._raiseEvent("stateChanged", args);
        this._raiseEvent("propertyChanged", args);
    }

    function Ee$UI$Xaml$Media$Player$_raiseVolumeChanged(args) {
        this.onVolumeChanged(args);
        this._raiseEvent("volumeChanged", args);
        this.raisePropertyChanged("volume");
    }

    function Ee$UI$Xaml$Media$Player$_skipTime(direction) {
        // skipping always skips by 10% of the total duration
        var delta = this._naturalduration / 10;
        // always skip by at least 5 seconds
        delta = direction * Math.max(5, delta);
        var newTime = delta + this.get_timeIndex();
        this.set_timeIndex(newTime);
    }

    function Ee$UI$Xaml$Media$Player$_tickTimer() {
        this._timerCookie = window.setTimeout(this._tickTimerDelegate, 100);
        var time = this.get_timeIndex();
        if (this._hasDuration) {
            if (!this._dragTime._isDragging) {
                this._dragTime.set_value(time / this._naturalduration);
            }
            this._updateTime(time);
        }
        if (this._canSeek) {
            this._detectChapterChanged(time);
        }
    }

    function Ee$UI$Xaml$Media$Player$_updateTime(time) {
        this._currentTimeText.set_text(this._formatTime(time * 1000));
    }
Ee.UI.Xaml.Media.Player.prototype = {
    _mediaEnded: false,
    _naturalduration: null,
    _domElements: null,
    _timerCookie: null,
    _mediaOpened: true,
    _enabledCaptionToggleButton: false,
    _autoPlay: null,
    _canSeek: true,
    _hasDuration: true,
    _caption: null,
    _chapters: null,
    _currentChapter: -1,
    _lastChapterStarted: -1,
    _nextChapterTime: -1,
    _currentChapterTime: -1,
    _enableCaptions: true,
    _toggledCaptions: true,
    _mediaMarkers: null,
    _mediaUrl: null,
    _muted: null,
    _placeholderImage: null,
    _imageElement: null,
    _volume: null,
    _chaptersActive: false,
    _bufferingProgressVisible: false,
    // controls
    _bufferingProgress: null,
    _bufferingStoryboard: null,
    _bufferingText: null,
    _captionButton: null,
    _captionArea: null,
    _captionAreaFS: null,
    _chapterArea: null,
    _currentTimeText: null,
    _downloadProgress: null,
    _dragTime: null,
    _dragVolume: null,
    _mediaElement: null,
    _muteButton: null,
    _nextButton: null,
    _playPauseButton: null,
    _playButton: null,
    _pauseButton: null,
    _stopButton: null,
    _previousButton: null,
    _totalTimeText: null,
    
    add_chapterStarted: Ee$UI$Xaml$Media$Player$add_chapterStarted,
    remove_chapterStarted: Ee$UI$Xaml$Media$Player$remove_chapterStarted,

    add_markerReached: Ee$UI$Xaml$Media$Player$add_markerReached,
    remove_markerReached: Ee$UI$Xaml$Media$Player$remove_markerReached,

    add_mediaEnded: Ee$UI$Xaml$Media$Player$add_mediaEnded,
    remove_mediaEnded: Ee$UI$Xaml$Media$Player$remove_mediaEnded,

    add_mediaFailed: Ee$UI$Xaml$Media$Player$add_mediaFailed,
    remove_mediaFailed: Ee$UI$Xaml$Media$Player$remove_mediaFailed,

    add_mediaOpened: Ee$UI$Xaml$Media$Player$add_mediaOpened,
    remove_mediaOpened: Ee$UI$Xaml$Media$Player$remove_mediaOpened,

    add_stateChanged: Ee$UI$Xaml$Media$Player$add_stateChanged,
    remove_stateChanged: Ee$UI$Xaml$Media$Player$remove_stateChanged,

    add_volumeChanged: Ee$UI$Xaml$Media$Player$add_volumeChanged,
    remove_volumeChanged: Ee$UI$Xaml$Media$Player$remove_volumeChanged,

    get_autoPlay: Ee$UI$Xaml$Media$Player$get_autoPlay,
    set_autoPlay: Ee$UI$Xaml$Media$Player$set_autoPlay,

    get_caption: Ee$UI$Xaml$Media$Player$get_caption,
    set_caption: Ee$UI$Xaml$Media$Player$set_caption,

    get_chapters: Ee$UI$Xaml$Media$Player$get_chapters,
    set_chapters: Ee$UI$Xaml$Media$Player$set_chapters,

    get_currentChapter: Ee$UI$Xaml$Media$Player$get_currentChapter,
    set_currentChapter: Ee$UI$Xaml$Media$Player$set_currentChapter,

    get_enableCaptions: Ee$UI$Xaml$Media$Player$get_enableCaptions,
    set_enableCaptions: Ee$UI$Xaml$Media$Player$set_enableCaptions,
    
    get_mediaMarkers: Ee$UI$Xaml$Media$Player$get_mediaMarkers,
    
    get_mediaElement: Ee$UI$Xaml$Media$Player$get_mediaElement,

    get_mediaUrl: Ee$UI$Xaml$Media$Player$get_mediaUrl,
    set_mediaUrl: Ee$UI$Xaml$Media$Player$set_mediaUrl,

    get_muted: Ee$UI$Xaml$Media$Player$get_muted,
    set_muted: Ee$UI$Xaml$Media$Player$set_muted,

    get_placeholderImage: Ee$UI$Xaml$Media$Player$get_placeholderImage,
    set_placeholderImage: Ee$UI$Xaml$Media$Player$set_placeholderImage,

    get_playState: Ee$UI$Xaml$Media$Player$get_playState,

    get_timeIndex: Ee$UI$Xaml$Media$Player$get_timeIndex,
    set_timeIndex: Ee$UI$Xaml$Media$Player$set_timeIndex,
    
    get_volume: Ee$UI$Xaml$Media$Player$get_volume,
    set_volume: Ee$UI$Xaml$Media$Player$set_volume,

    nextChapter: Ee$UI$Xaml$Media$Player$nextChapter,

    onChapterStarted: Ee$UI$Xaml$Media$Player$onChapterStarted,

    onMarkerReached: Ee$UI$Xaml$Media$Player$onMarkerReached,

    onPlayStateChanged: Ee$UI$Xaml$Media$Player$onPlayStateChanged,

    onVolumeChanged: Ee$UI$Xaml$Media$Player$onVolumeChanged,

    pause: Ee$UI$Xaml$Media$Player$pause,

    play: Ee$UI$Xaml$Media$Player$play,

    previousChapter: Ee$UI$Xaml$Media$Player$previousChapter,
    
    stop: Ee$UI$Xaml$Media$Player$stop,

    toggleMuted: Ee$UI$Xaml$Media$Player$toggleMuted,

    togglePlayPause: Ee$UI$Xaml$Media$Player$togglePlayPause,
    
    xamlDispose: Ee$UI$Xaml$Media$Player$xamlDispose,   

    xamlInitialize: Ee$UI$Xaml$Media$Player$xamlInitialize,

    _bindChildControls: Ee$UI$Xaml$Media$Player$_bindChildControls,
    
    _chapterNext: Ee$UI$Xaml$Media$Player$_chapterNext,
        
    _chapterPrevious: Ee$UI$Xaml$Media$Player$_chapterPrevious,
    
    _clearMediaCache: Ee$UI$Xaml$Media$Player$_clearMediaCache,
    
    _detectChapterChanged: Ee$UI$Xaml$Media$Player$_detectChapterChanged,

    _enableBuffering: Ee$UI$Xaml$Media$Player$_enableBuffering,
    
    _ensureCaption: Ee$UI$Xaml$Media$Player$_ensureCaption,

    _ensureChapterArea: Ee$UI$Xaml$Media$Player$_ensureChapterArea,
    
    _ensureSeeking: Ee$UI$Xaml$Media$Player$_ensureSeeking,
    
    _ensureDuration: Ee$UI$Xaml$Media$Player$_ensureDuration,

    _formatTime: Ee$UI$Xaml$Media$Player$_formatTime,

    _fullScreenChanged: Ee$UI$Xaml$Media$Player$_fullScreenChanged,
    
    _getChapterAt: Ee$UI$Xaml$Media$Player$_getChapterAt,
    
    _getMediaFailedError: Ee$UI$Xaml$Media$Player$_getMediaFailedError,

    _loadChapters: Ee$UI$Xaml$Media$Player$_loadChapters,

    _loadMediaUrl: Ee$UI$Xaml$Media$Player$_loadMediaUrl,    
    
    _loadPlaceholderImage: Ee$UI$Xaml$Media$Player$_loadPlaceholderImage,
    
    _onCaptionToggle: Ee$UI$Xaml$Media$Player$_onCaptionToggle,

    _onFullScreen: Ee$UI$Xaml$Media$Player$_onFullScreen,
    _onFullScreenME: Ee$UI$Xaml$Media$Player$_onFullScreenME,
    _onTimeSliderChanged: Ee$UI$Xaml$Media$Player$_onTimeSliderChanged,
    _onVolumeDown: Ee$UI$Xaml$Media$Player$_onVolumeDown,
    _onVolumeSliderChanged: Ee$UI$Xaml$Media$Player$_onVolumeSliderChanged,
    _onVolumeUp: Ee$UI$Xaml$Media$Player$_onVolumeUp,
    
    _mediaAvailable: Ee$UI$Xaml$Media$Player$_mediaAvailable,

    _meBufferingProgress: Ee$UI$Xaml$Media$Player$_meBufferingProgress,
    
    _meDownloadProgress: Ee$UI$Xaml$Media$Player$_meDownloadProgress,

    _meMarkerReached: Ee$UI$Xaml$Media$Player$_meMarkerReached,
    
    _meMediaEnded: Ee$UI$Xaml$Media$Player$_meMediaEnded,

    _meMediaFailed: Ee$UI$Xaml$Media$Player$_meMediaFailed,

    _meMediaOpened: Ee$UI$Xaml$Media$Player$_meMediaOpened,
    
    _meStateChanged: Ee$UI$Xaml$Media$Player$_meStateChanged,
    
    _raiseChapterStarted: Ee$UI$Xaml$Media$Player$_raiseChapterStarted,
    
    _raiseEvent: Ee$UI$Xaml$Media$Player$_raiseEvent,
    
    _raiseMarkerReached: Ee$UI$Xaml$Media$Player$_raiseMarkerReached,
    
    _raisePlayStateChanged: Ee$UI$Xaml$Media$Player$_raisePlayStateChanged,    
    
    _raiseVolumeChanged: Ee$UI$Xaml$Media$Player$_raiseVolumeChanged,
    
    _skipTime: Ee$UI$Xaml$Media$Player$_skipTime,
    
    _tickTimer: Ee$UI$Xaml$Media$Player$_tickTimer,
    
    _updateTime: Ee$UI$Xaml$Media$Player$_updateTime
}
Ee.UI.Xaml.Media.Player._defaultVolume = 0.5;
Ee.UI.Xaml.Media.Player.registerClass('Ee.UI.Xaml.Media.Player', Ee.UI.Xaml.Control);

Ee.UI.Xaml.Media.StateChangedEventArgs = function Ee$UI$Xaml$Media$StateChangedEventArgs(propertyName, previousState, currentState) {
    /// <param name="propertyName" type="String"></param>
    /// <param name="previousState"></param>
    /// <param name="currentState"></param>
    var e = Function._validateParams(arguments, [
        {name: "propertyName", type: String},
        {name: "previousState"},
        {name: "currentState"}
    ]);
    if (e) throw e;

    this._currentState = currentState;
    this._previousState = previousState;
    Ee.UI.Xaml.Media.StateChangedEventArgs.initializeBase(this, [propertyName]);
}

    function Ee$UI$Xaml$Media$StateChangedEventArgs$get_currentState() {
        /// <value></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._currentState || null;
    }
    function Ee$UI$Xaml$Media$StateChangedEventArgs$get_previousState() {
        /// <value></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._previousState || null;
    }
Ee.UI.Xaml.Media.StateChangedEventArgs.prototype = {
    get_currentState: Ee$UI$Xaml$Media$StateChangedEventArgs$get_currentState,
    get_previousState: Ee$UI$Xaml$Media$StateChangedEventArgs$get_previousState
}
Ee.UI.Xaml.Media.StateChangedEventArgs.registerClass("Ee.UI.Xaml.Media.StateChangedEventArgs", Sys.PropertyChangedEventArgs);
Ee.UI.Xaml.Media.ChapterEventArgs = function Ee$UI$Xaml$Media$ChapterEventArgs(chapterIndex) {
    /// <param name="chapterIndex" type="Number"></param>
    var e = Function._validateParams(arguments, [
        {name: "chapterIndex", type: Number}
    ]);
    if (e) throw e;

    this._chapterIndex = chapterIndex;
    Ee.UI.Xaml.Media.ChapterEventArgs.initializeBase(this);
}

    function Ee$UI$Xaml$Media$ChapterEventArgs$get_chapterIndex() {
        /// <value type="Number"></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._chapterIndex;
    }
Ee.UI.Xaml.Media.ChapterEventArgs.prototype = {
    get_chapterIndex: Ee$UI$Xaml$Media$ChapterEventArgs$get_chapterIndex
}
Ee.UI.Xaml.Media.ChapterEventArgs.registerClass("Ee.UI.Xaml.Media.ChapterEventArgs", Sys.EventArgs);
Ee.UI.Xaml.Media.MarkerEventArgs = function Ee$UI$Xaml$Media$MarkerEventArgs(marker) {
    /// <param name="marker"></param>
    var e = Function._validateParams(arguments, [
        {name: "marker"}
    ]);
    if (e) throw e;

    this._marker = marker;
    Ee.UI.Xaml.Media.MarkerEventArgs.initializeBase(this);
}

    function Ee$UI$Xaml$Media$MarkerEventArgs$get_marker() {
        /// <value></value>
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._marker || null;
    }
Ee.UI.Xaml.Media.MarkerEventArgs.prototype = {
    get_marker: Ee$UI$Xaml$Media$MarkerEventArgs$get_marker
}
Ee.UI.Xaml.Media.MarkerEventArgs.registerClass("Ee.UI.Xaml.Media.MarkerEventArgs", Sys.EventArgs);

Ee.UI.Xaml.Media._TextBlock = function Ee$UI$Xaml$Media$_TextBlock(host, textBlockElementName, backgroundElementName) {
    // <param name="host">Silverlight host</param>
    // <param name="textBlockElementName" type="String">Name of XAML TextBlock</param>
    // <param name="backgroundElementName" type="String" optional="true" mayBeNull="true">Name of XAML element that will serve as a background for the text block, if any</param>
    Ee.UI.Xaml.Media._TextBlock.initializeBase(this, [host, textBlockElementName]);
    var control = this.get_control();
    if (control && backgroundElementName) {
        var bg = control.findName(backgroundElementName);
        if (bg) {
            this._centerX = bg["Canvas.Left"] + bg.width / 2;
            this._bottomY = bg["Canvas.Top"] + bg.height;
            this._background = bg;
        }
    }

    if (control && !this._background && textBlockElementName) {
        var bg = control.findName(textBlockElementName);
        if (bg) {
            this._centerX = bg["Canvas.Left"] + bg.ActualWidth / 2;
            this._bottomY = bg["Canvas.Top"] + bg.ActualHeight;
            this._background = bg;
        }
    }

}





    function Ee$UI$Xaml$Media$_TextBlock$get_backgroundControl() {
        if (arguments.length !== 0) throw Error.parameterCount();
        // <value mayBeNull="true">The Silverlight control that acts as the background for the text block.</value>
        return this._background || null;
    }

    function Ee$UI$Xaml$Media$_TextBlock$get_text() {
        if (arguments.length !== 0) throw Error.parameterCount();
        // <value type="String" mayBeNull="true"></value>
        var control = this.get_control();
        return control ? (control.Text || "") : "";
    }
    function Ee$UI$Xaml$Media$_TextBlock$set_text(value) {
        var control = this.get_control();
        if (control) {
            control.Text = value || "";
            this.setVisible(!!value);
            var bg = this.get_backgroundControl();
            if (bg) {
                var x = control.ActualWidth;
                var y = control.ActualHeight;
                bg["Canvas.Left"] = this._centerX - x / 2;
                bg["Canvas.Top"] = this._bottomY - y;
                bg.width = x;
                bg.height = y;
            }
        }
    }

    function Ee$UI$Xaml$Media$_TextBlock$dispose() {
        Ee.UI.Xaml.Media._TextBlock.callBaseMethod(this, "dispose");
        this._background = null;
    }

    function Ee$UI$Xaml$Media$_TextBlock$setVisible(value) {
        Ee.UI.Xaml.Media._TextBlock.callBaseMethod(this, "setVisible", [value]);
        var c = this.get_backgroundControl();
        if (c) c.visibility = value ? 0 : 1;        
    }
Ee.UI.Xaml.Media._TextBlock.prototype = {
    _centerX: 0,
    _bottomY: 0,
    _background: null,
    
    get_backgroundControl: Ee$UI$Xaml$Media$_TextBlock$get_backgroundControl,
    
    get_text: Ee$UI$Xaml$Media$_TextBlock$get_text,
    set_text: Ee$UI$Xaml$Media$_TextBlock$set_text,

    dispose: Ee$UI$Xaml$Media$_TextBlock$dispose,
    
    setVisible: Ee$UI$Xaml$Media$_TextBlock$setVisible
}
Ee.UI.Xaml.Media._TextBlock.registerClass('Ee.UI.Xaml.Media._TextBlock', Ee.UI.Xaml.Media._DomElement);
Ee.UI.Xaml.Media._MultiStateButton = function Ee$UI$Xaml$Media$_MultiStateButton(host, nameElement, autorepeatInterval, clickHandler, doubleClickHandler, handlerOwner, stateList) {
    Ee.UI.Xaml.Media._MultiStateButton.initializeBase(this, [host, nameElement, autorepeatInterval, clickHandler, doubleClickHandler, handlerOwner]);
    // animations for state changes
    var stateCount = arguments.length-6;
    
    
    this._animationsOn = new Array(stateCount);
    this._animationsOff = new Array(stateCount);
    this._controls = new Array(stateCount);

    var control = this.get_control();
    for (var i = 0; i < stateCount; i++) {
        var nameControl = arguments[i + 6];
        var ctl = control ? control.findName(nameControl) : null;
        // check for (control)_Show and (control)_Hide
        this._controls[i] = ctl || null;
        this._animationsOn[i] = ctl ? ctl.findName(nameControl + "_Show") : null;
        this._animationsOff[i] = ctl ? ctl.findName(nameControl + "_Hide") : null;
    }
}






    function Ee$UI$Xaml$Media$_MultiStateButton$get_state() {
        if (arguments.length !== 0) throw Error.parameterCount();
        // <value type="Number" integer="true">current button state</value>
        return this._state;
    }
    function Ee$UI$Xaml$Media$_MultiStateButton$set_state(value) {
        
        if (value !== this._state) {
            var a = this._animationsOff[this._state];
            if (a) {
                a.begin();
            }
            else {
                var cOff = this._controls[this._state];
                if (cOff) cOff.visibility = 1;
            }
            this._state = value;
            a = this._animationsOn[this._state];
            if (a) {
                a.begin();
            }
            else {
                var cOn = this._controls[this._state];
                if (cOn) cOn.visibility = 0;
            }
        }
    }

    function Ee$UI$Xaml$Media$_MultiStateButton$dispose() {
        Ee.UI.Xaml.Media._MultiStateButton.callBaseMethod(this, "dispose");
        this._animationsOn = null;
        this._animationsOff = null;
        this._controls = null;
        this._state = 0;
    }
Ee.UI.Xaml.Media._MultiStateButton.prototype = {
    _state: 0,
    _animationsOn: null,
    _animationsOff: null,
    _controls: null,
    
    get_state: Ee$UI$Xaml$Media$_MultiStateButton$get_state,
    set_state: Ee$UI$Xaml$Media$_MultiStateButton$set_state,
    
    dispose: Ee$UI$Xaml$Media$_MultiStateButton$dispose
}
Ee.UI.Xaml.Media._MultiStateButton.registerClass('Ee.UI.Xaml.Media._MultiStateButton', Ee.UI.Xaml.Media._Button);

Ee.UI.Xaml.Media._ImageList = function Ee$UI$Xaml$Media$_ImageList(host, imageListName) {
    // Implements the script required to drive a horizontal ImageList.
    // The ImageList is xaml that contains the following structure:
    // TODO: explaination
    Ee.UI.Xaml.Media._ImageList.initializeBase(this, [host, imageListName]);
    var control = this.get_control();
    if (!control) return;
    control.cursor = "Arrow";

    this._scrollAnimationSB = control.findName(imageListName + "_ScrollAnimationStoryboard");
    if (this._scrollAnimationSB) this._scrollAnimation = control.findName(imageListName + "_ScrollAnimation");
    
    var interval = this._scrollAnimation ? (this._scrollAnimation.duration.seconds*1000) : 200;
    interval = Math.max(interval, 200);
    this._scrollNext = new Ee.UI.Xaml.Media._Button(host, imageListName + "_ScrollNext", interval, this._scrollNextClick, null, this);
	this._scrollPrev = new Ee.UI.Xaml.Media._Button(host, imageListName + "_ScrollPrevious", interval, this._scrollPrevClick, null, this);
	
	this._findItems(imageListName);
	this._virtualItems = [];
}











    function Ee$UI$Xaml$Media$_ImageList$get_items() {
        if (arguments.length !== 0) throw Error.parameterCount();
        return this._virtualItems;
    }
    function Ee$UI$Xaml$Media$_ImageList$set_items(value) {
        this._virtualItems = Array.clone(value);
        this._reset();
        this._assignImages();
    }

    function Ee$UI$Xaml$Media$_ImageList$onItemClick(virtualIndex) {
    }

    function Ee$UI$Xaml$Media$_ImageList$_assignImages() {
        for (var i = 0, l = this._items.length; i < l; i++) {
            var item = this._items[i];
            var offset = this._itemOffset + i;
            if (offset < this._virtualItems.length) {
                item.image.Source = this._virtualItems[offset];
                item.button.get_control().visibility = 0; // visible
                item.button._virtualIndex = offset;
            }
            else {
                item.button.get_control().visibility = 1; // collapsed
            }
        }
    }

    function Ee$UI$Xaml$Media$_ImageList$_findItems(baseName) {
        var control = this.get_control();
        var i = 1;
        this._items = [];
        var itemName = baseName + "_ScrollItem1",
            imageName = baseName + "_ScrollItem1_Image",
            item = control.findName(itemName),
            image = control.findName(imageName);

        while(item) {
            var btn = new Ee.UI.Xaml.Media._Button(
                        control.getHost(), itemName, null,
                        this._itemClick, null, this, /*requiresSender*/true);
            btn._physicalIndex = i-1;
            this._items[this._items.length] = { button: btn, image: image };
            i++;
            itemName = baseName + "_ScrollItem" + i;
            imageName = baseName + "_ScrollItem" + i + "_Image";
            item = control.findName(itemName);
            image = control.findName(imageName);
        }

        if (this._items.length === 0) {
            throw Error.invalidOperation("ImageList needs at least one scroll item.");
        }

        var firstItem = this._items[0].button.get_control();
        this._itemSize = firstItem.width;
        //this._itemSpacing = (firstItem["Canvas.Left"] - firstItem.getParent()["Canvas.Left"]) * 2;
        this._itemSpacing = firstItem["Canvas.Left"] * 2;
    }

    function Ee$UI$Xaml$Media$_ImageList$_handleOverflow(direction) {
        // ensures the overflow item is in the right position
        
        // determine virtual index of the overflow item
        var layoutIndex = direction === 1 ? (this._items.length-1) : -1;
        var virtualIndex = this._itemOffset + layoutIndex;
        
        // assign virtual item data to the overflow item
        var overflowItem = this._items[this._overflowIndex];
        overflowItem.image.Source = this._virtualItems[virtualIndex];
        overflowItem.button._virtualIndex = virtualIndex;
        
        // position the overflow item
        var button = overflowItem.button.get_control();
        button["Canvas.Left"] = virtualIndex * (this._itemSize + this._itemSpacing) + (this._itemSpacing / 2);
        
        // overflow item is no longer an overflow item, advance the index
        this._overflowIndex += direction;
        if (this._overflowIndex < 0) {
            this._overflowIndex = this._items.length - 1;
        }
        else if (this._overflowIndex >= this._items.length) {
            this._overflowIndex = 0;
        }
    }

    function Ee$UI$Xaml$Media$_ImageList$_itemClick(sender) {
        // sender given because Button was instantiated with requiresSender=true
        this.onItemClick(sender._virtualIndex);
    }

    function Ee$UI$Xaml$Media$_ImageList$_reset() {
	    this._itemOffset = 0;
	    for (var i = 0, l = this._items.length; i < l; i++) {
	        var button = this._items[i].button;
	        button._virtualIndex = i;
    	    button.get_control()["Canvas.Left"] = i * (this._itemSize + this._itemSpacing) + (this._itemSpacing/2);
	    }
	    this._overflowIndex = this._items.length - 1;
	    // ensure scrolled to the beginning
        if (this._scrollAnimation) {
            this._scrollAnimation.To = "0";
            this._scrollAnimationSB.begin();
        }
    }

    function Ee$UI$Xaml$Media$_ImageList$_scroll(direction) {
        if (this._scrollAnimation) {
            this._handleOverflow(direction);

            var fromOffset = this._itemOffset;
            this._itemOffset += direction;

            this._scrollAnimation.From = "-" + (fromOffset * (this._itemSize + this._itemSpacing));
            this._scrollAnimation.To = "-" + (this._itemOffset * (this._itemSize + this._itemSpacing));
            this._scrollAnimationSB.begin();
        }
        else {
            this._itemOffset += direction;
            this._assignImages();            
        }
    }

    function Ee$UI$Xaml$Media$_ImageList$_scrollNextClick() {
        if (this._itemOffset < (this._virtualItems.length - this._items.length + 1)) {
            this._scroll(1);
        }
    }

    function Ee$UI$Xaml$Media$_ImageList$_scrollPrevClick() {
        if (this._itemOffset > 0) {
            this._scroll(-1);
        }
    }

    function Ee$UI$Xaml$Media$_ImageList$dispose() {
        if (this._scrollNext) this._scrollNext.dispose();
        if (this._scrollPrev) this._scrollPrev.dispose();
        this._scrollNext = null;
        this._scrollPrev = null;

        if (this._items) {
            for (var i = 0, l = this._items.length; i < l; i++) {
                var button = this._items[i].button;
                button.dispose();
            }
            this._items = null;
        }     
        this._virtualItems = null;
        this._itemSize = null;
        this._itemSpacing = null;
        this._scrollAnimation = null;
        this._scrollAnimationSB = null;
        Ee.UI.Xaml.Media._ImageList.callBaseMethod(this, "dispose");
    }
Ee.UI.Xaml.Media._ImageList.prototype = {
    _items: null,
    _virtualItems: null,
    _scrollNext: null,
    _scrollPrev: null,
    _scrollAnimation: null,
    _scrollAnimationSB: null,
    _itemSize: 0,
    _itemSpacing: 0,
    _overflowIndex: 0,
    
    get_items: Ee$UI$Xaml$Media$_ImageList$get_items,
    set_items: Ee$UI$Xaml$Media$_ImageList$set_items,
    
    onItemClick: Ee$UI$Xaml$Media$_ImageList$onItemClick,    
    
    _assignImages: Ee$UI$Xaml$Media$_ImageList$_assignImages,
    
    _findItems: Ee$UI$Xaml$Media$_ImageList$_findItems,
    
    _handleOverflow: Ee$UI$Xaml$Media$_ImageList$_handleOverflow,
    
    _itemClick: Ee$UI$Xaml$Media$_ImageList$_itemClick,
    
    _reset: Ee$UI$Xaml$Media$_ImageList$_reset,
    
    _scroll: Ee$UI$Xaml$Media$_ImageList$_scroll,
    
    _scrollNextClick: Ee$UI$Xaml$Media$_ImageList$_scrollNextClick,
    
    _scrollPrevClick: Ee$UI$Xaml$Media$_ImageList$_scrollPrevClick,

    dispose: Ee$UI$Xaml$Media$_ImageList$dispose
}
Ee.UI.Xaml.Media._ImageList.registerClass('Ee.UI.Xaml.Media._ImageList', Ee.UI.Xaml.Media._DomElement);
Ee.UI.Xaml.Media._ChapterArea = function Ee$UI$Xaml$Media$_ChapterArea(player) {
    this._player = player;
    var names = Ee.UI.Xaml.Media.PlayerElementName;
    Ee.UI.Xaml.Media._ChapterArea.initializeBase(this, [player.get_element(), names.chapterArea]);
    var control = this.get_control();
    if (control) {
        this._toggleButton = new Ee.UI.Xaml.Media._Button(player.get_element(), names.chapterToggleButton, null, this._onToggle, null, this);
    }
}





    function Ee$UI$Xaml$Media$_ChapterArea$activate() {
        // activate means there are chapters to be shown, so the chapter area should be 'activated', but not necessarily visible.
        // for example, a chapter area that is only visible when the mouse is over it. It should be active in that it shows when you
        // hover over it, but not always visible. We use visibility to activate/deactivate, the skin defines its own _Hide and _Show
        // animation which we control via the toggle button (or they could define a MouseEnter MouseLeave for simply reveal opacity).
        // If there are no chapters for the media, the chapter area is deactivated (e.g. so no hover occurs) and the toggle button is
        // hidden (if it exists).
        var c = this.get_control();
        if (!c) return;
        c.visibility = 0;
        this._toggleButton.setVisible(true);
    }

    function Ee$UI$Xaml$Media$_ChapterArea$deactivate() {
        var c = this.get_control();
        if (!c) return;
        c.visibility = 1;
        this._toggleButton.setVisible(false);
    }

    function Ee$UI$Xaml$Media$_ChapterArea$dispose() {
        Ee.UI.Xaml.Media._ChapterArea.callBaseMethod(this, "dispose");
        this._player = null;
        if (this._toggleButton) this._toggleButton.dispose();
        this._toggleButton = null;
    }

    function Ee$UI$Xaml$Media$_ChapterArea$onItemClick(index) {
        this._player.set_currentChapter(this._imageChapters[index]);
    }

    function Ee$UI$Xaml$Media$_ChapterArea$setChapters(chapters) {
        // <param name="chapters" type="Array" mayBeNull="true" elementMayBeNull="true">Array of chapters.</param>
        if (!this.get_control()) return;
        var imageArray = [];
        // only care about chapters that have images with them
        if (chapters) {
            this._imageChapters = [];
            for (var i = 0, l = chapters.length; i < l; i++) {
                var chapter = chapters[i];
                if (chapter.imageUrl) {
                    this._imageChapters[this._imageChapters.length] = i;
                    imageArray[imageArray.length] = chapter.imageUrl;
                }
            }
        }
        this.set_items(imageArray);
    }

    function Ee$UI$Xaml$Media$_ChapterArea$_onToggle() {
        this._visible = !this._visible;
        this.setVisible(this._visible);
        var c = this.get_control();
        // make sure the chapter area isn't hit testable when its supposed to be hidden
        if (c) c.IsHitTestVisible = this._visible;
    }
Ee.UI.Xaml.Media._ChapterArea.prototype = {
    _player: null,
    _visible: false,
    _toggleButton: null,
    
    activate: Ee$UI$Xaml$Media$_ChapterArea$activate,
    
    deactivate: Ee$UI$Xaml$Media$_ChapterArea$deactivate,
    
    dispose: Ee$UI$Xaml$Media$_ChapterArea$dispose,

    onItemClick: Ee$UI$Xaml$Media$_ChapterArea$onItemClick,
    
    setChapters: Ee$UI$Xaml$Media$_ChapterArea$setChapters,
    
    _onToggle: Ee$UI$Xaml$Media$_ChapterArea$_onToggle
}
Ee.UI.Xaml.Media._ChapterArea.registerClass('Ee.UI.Xaml.Media._ChapterArea', Ee.UI.Xaml.Media._ImageList);

Ee.UI.Xaml.Media._Slider = function Ee$UI$Xaml$Media$_Slider(host, nameThumb, nameSlider, valueChangedHandler, handlerOwner) {
    // assumption: the thumb and slider canvases are siblings.
    Ee.UI.Xaml.Media._Slider.initializeBase(this, [host, nameSlider]);
    
    this._slider = this.get_control();
    this._thumb = new Ee.UI.Xaml.Media._DomElement(host, nameThumb);
    this._thumbControl = this._thumb.get_control();

    if (!this._thumbControl || !this._slider) {
        return;
    }
    this._highlight = new Ee.UI.Xaml.Media._DomElement(host, nameSlider + "_Highlight");
    this._highlightControl = this._highlight.get_control();
    
    this._slider.cursor = "Hand";
    this._thumbControl.cursor = "Hand";

    this._thumb.bindEvent("mouseLeftButtonDown", null, this._thumbMouseLeftButtonDown, this);
    this._thumb.bindEvent("mouseLeftButtonUp", null, this._thumbMouseLeftButtonUp, this);
    this._thumb.bindEvent("mouseMove", null, this._thumbMouseMove, this);
    this.bindEvent("mouseLeftButtonDown", null, this._sliderLeftButtonDown, this);
    
    // get to the root canvas and listen to its mouseLeave, so that we can ensure we know when
    // we loose mouse capture when the mouse leaves the silverlight host
    this._rootToken = this._slider.getHost().content.root.addEventListener("mouseLeave", Function.createDelegate(this, this._cancelDragging));

    this._isHorizontal = (this._slider.width >= this._slider.height);

    if (this._highlightControl) {
        this._highlightControl[this._isHorizontal ? "width" : "height"] = 0;
    }

    if (handlerOwner) {
        this._changedHandler = Function.createDelegate(handlerOwner, valueChangedHandler);
    }
}











    function Ee$UI$Xaml$Media$_Slider$set_enabled(value) {
        if (this.get_enabled() !== value) {
            Ee.UI.Xaml.Media._Slider.callBaseMethod(this, "set_enabled", [value]);
            // highlight bar should not respond when time is not shown
            this._highlight.set_enabled(value);
            // thumb should fade away when time disabled
            this._thumb.setVisible(value);
            // thumb should not have hand cursor when disabled
            if (this._thumbControl) this._thumbControl.cursor = value ? "Hand" : "Default";
            // slider's position should be 0 when disabled
            if (!value) this.set_value(0);
            // slider should not have hand cursor when disabled
            if (this._slider) this._slider.cursor = value ? "Hand" : "Default";
        }        
    }

    function Ee$UI$Xaml$Media$_Slider$get_enableSeeking() {
        if (arguments.length !== 0) throw Error.parameterCount();
        return !!this._enableSeeking;
    }
    function Ee$UI$Xaml$Media$_Slider$set_enableSeeking(value) {
        if (this._enableSeeking !== value) {
            this._enableSeeking = value;
            if (!value) this._cancelDragging();
        }
    }

    function Ee$UI$Xaml$Media$_Slider$get_value() {
        if (arguments.length !== 0) throw Error.parameterCount();
        // <value type="Number">A number between 0 and 1 representing the current position of the slider's thumb.</value>
        if (!this._thumbControl || !this._slider) return 0;

        var val;
        if (this._isHorizontal) {
            //val = this._thumbControl["Canvas.Left"] - this._slider["Canvas.Left"] + (this._thumbControl.width/2);
            val = this._thumbControl["Canvas.Left"] - this._slider["Canvas.Left"];
            val = val / (this._slider.width - this._thumbControl.width);
        }
        else {
            val = this._thumbControl["Canvas.Top"] - this._slider["Canvas.Top"] + (this._thumbControl.height/2);
            val = 1 - (val / this._slider.height);
        }
        // make value accurate to 0.001
        val = Math.round(val*1000)/1000;
        return Math.min(1, Math.max(0, val));
    }
    function Ee$UI$Xaml$Media$_Slider$set_value(value) {
        value = Math.min(1, Math.max(0, value));
        this._setThumbPosition(value);
    }

    function Ee$UI$Xaml$Media$_Slider$dispose() {
        if (this._highlight) this._highlight.dispose();
        if (this._thumb) this._thumb.dispose();
        this._changedHandler = null;
        if (this._rootToken) this._slider.getHost().content.root.removeEventListener("mouseLeave", this._rootToken);
        this._slider = null;
        this._thumb = null;
        this._thumbControl = null;
        this._rootToken = null;
        this._highlight = null;
        this._highlightControl = null;
        Ee.UI.Xaml.Media._Slider.callBaseMethod(this, 'dispose');                
    }

    function Ee$UI$Xaml$Media$_Slider$_cancelDragging() {
        if (this._isDragging) {
            this._isDragging = false;
            this._thumbControl.ReleaseMouseCapture();
        }
    }

    function Ee$UI$Xaml$Media$_Slider$_setThumbPosition(value) {
        if (this._thumbControl && this._slider) {
            var loc = this._toLocation(value);
            if (this._isHorizontal) {
                this._thumbControl["Canvas.Left"] = this._slider["Canvas.Left"] + loc - (this._thumbControl.width/2);
                if (this._highlightControl) this._highlightControl.width = loc + (this._thumbControl.width/2);
            }
            else {
                this._thumbControl["Canvas.Top"] = this._slider["Canvas.Top"] + loc - (this._thumbControl.height/2);
                if (this._highlightControl) {
                    this._highlightControl["Canvas.Top"] = this._thumbControl["Canvas.Top"] + (this._thumbControl.height/2);
                    this._highlightControl.height = value * (this._slider.height - this._thumbControl.height) - (this._thumbControl.height/2);
                }
            }
        }
    }

    function Ee$UI$Xaml$Media$_Slider$_sliderLeftButtonDown(sender, eventArgs) {
        if (!this._enableSeeking) return false;
        var newValue = this._toValue(eventArgs.getPosition(sender));
        this._setThumbPosition(newValue);
        if (this._changedHandler) this._changedHandler();
        if (this._thumbControl) {
            this._isDragging = true;
            this._thumbControl.CaptureMouse();
        }
        return true;
    }

    function Ee$UI$Xaml$Media$_Slider$_thumbMouseLeftButtonDown() {
        if (!this._enableSeeking) return false;
        this._isDragging = true;
        this._thumbControl.CaptureMouse();
        return true;
    }

    function Ee$UI$Xaml$Media$_Slider$_thumbMouseLeftButtonUp() {
        if (!this._enableSeeking) return false;
        this._isDragging = false;
        this._thumbControl.ReleaseMouseCapture();
        return true;
    }

    function Ee$UI$Xaml$Media$_Slider$_thumbMouseMove(sender, args) {
        if (this._isDragging) {
            this._setThumbPosition(this._toValue(args.getPosition(this._slider)));
            if (this._changedHandler) this._changedHandler();
        }
        return true;
    }

    function Ee$UI$Xaml$Media$_Slider$_toValue(point) {
        // converts a point which is relative to the Slider control's position to a logical slider value
        var val;
        if (this._isHorizontal) {
            val = (point.X - (this._thumbControl.width / 2)) / (this._slider.width - this._thumbControl.width);
        }
        else {
            val = (point.Y - (this._thumbControl.height / 2)) / (this._slider.height - this._thumbControl.height);
            val = 1 - val;
        }
        return Math.min(1, Math.max(0, val));
    }

    function Ee$UI$Xaml$Media$_Slider$_toLocation(value) {
        // converts a logical value into a point which is relative to the Slider control's position
        value = Math.min(1, Math.max(0, value));
        if (this._isHorizontal) {
            return (value * (this._slider.width - this._thumbControl.width)) + (this._thumbControl.width / 2);
        }
        else {
            var range = this._slider.height - this._thumbControl.height;
            return (range - (value * range)) + (this._thumbControl.height / 2);
        }
    }
Ee.UI.Xaml.Media._Slider.prototype = {
    _slider: null,
    _thumb: null,
    _thumbControl: null,
    _enableSeeking: true,
    _highlight: null,
    _highlightControl: null,
    _isDragging: false,
    _isHorizontal: true,
    _rootToken: null,

    set_enabled: Ee$UI$Xaml$Media$_Slider$set_enabled,
    
    get_enableSeeking: Ee$UI$Xaml$Media$_Slider$get_enableSeeking,
    set_enableSeeking: Ee$UI$Xaml$Media$_Slider$set_enableSeeking,

    get_value: Ee$UI$Xaml$Media$_Slider$get_value,
    set_value: Ee$UI$Xaml$Media$_Slider$set_value,
    
    dispose: Ee$UI$Xaml$Media$_Slider$dispose,    
    
    _cancelDragging: Ee$UI$Xaml$Media$_Slider$_cancelDragging,
    
    _setThumbPosition: Ee$UI$Xaml$Media$_Slider$_setThumbPosition,
    
    _sliderLeftButtonDown: Ee$UI$Xaml$Media$_Slider$_sliderLeftButtonDown,
    
    _thumbMouseLeftButtonDown: Ee$UI$Xaml$Media$_Slider$_thumbMouseLeftButtonDown,

    _thumbMouseLeftButtonUp: Ee$UI$Xaml$Media$_Slider$_thumbMouseLeftButtonUp,

    _thumbMouseMove: Ee$UI$Xaml$Media$_Slider$_thumbMouseMove,
    
    _toValue: Ee$UI$Xaml$Media$_Slider$_toValue,
    
    _toLocation: Ee$UI$Xaml$Media$_Slider$_toLocation    
}
Ee.UI.Xaml.Media._Slider.registerClass('Ee.UI.Xaml.Media._Slider', Ee.UI.Xaml.Media._DomElement);
Ee.UI.Xaml.Media._ProgressBar = function Ee$UI$Xaml$Media$_ProgressBar(host, nameSlider, nameText) {
    // <summary>An element whose width depends on the value.</summary>
    // <param name="host">The Silverlight host.</param>
    // <param name="nameSlider" type="String">name of XAML canvas that represents the slider, where the existing width is the 100% point</param>
    // <param name="nameText" type="String">Optional name of XAML TextBlock where the actual percentage amount should be displayed</param>
    Ee.UI.Xaml.Media._ProgressBar.initializeBase(this, [host, nameSlider]);
    
    var control = this.get_control();
    if (control) {
        this._originalWidth = control.width;
        control.width = 0;
    }
    if (nameText) {
        this._xamlText = new Ee.UI.Xaml.Media._TextBlock(host, nameText);
        this._xamlText.set_text("");
    }
}




    function Ee$UI$Xaml$Media$_ProgressBar$get_value() {
        if (arguments.length !== 0) throw Error.parameterCount();
        // <value type="Number">Progress value between 0 and 1.</value>
        var c = this.get_control();
        if (!c) return 0;
        return c.width / this._originalWidth;
    }
    function Ee$UI$Xaml$Media$_ProgressBar$set_value(value) {
        var c = this.get_control();
        if (c) c.width = this._originalWidth * value;
        this._xamlText.set_text("" + Math.floor(value * 100));
    }

    function Ee$UI$Xaml$Media$_ProgressBar$setVisible(value) {
        Ee.UI.Xaml.Media._ProgressBar.callBaseMethod(this, "setVisible", [value]);
        if (this._xamlText) this._xamlText.setVisible(value);
    }

    function Ee$UI$Xaml$Media$_ProgressBar$dispose() {
        Ee.UI.Xaml.Media._ProgressBar.callBaseMethod(this, "dispose");
        if (this._xamlText) {
            this._xamlText.dispose();
            this._xamlText = null;
        }
    }
Ee.UI.Xaml.Media._ProgressBar.prototype = {
    _xamlText: null,
    _originalWidth: 0,
    
    get_value: Ee$UI$Xaml$Media$_ProgressBar$get_value,
    set_value: Ee$UI$Xaml$Media$_ProgressBar$set_value,
    
    setVisible: Ee$UI$Xaml$Media$_ProgressBar$setVisible,
   
    dispose: Ee$UI$Xaml$Media$_ProgressBar$dispose
}
Ee.UI.Xaml.Media._ProgressBar.registerClass('Ee.UI.Xaml.Media._ProgressBar', Ee.UI.Xaml.Media._DomElement);


// EePlayer extends the BasePlayer player class, adding URL parsing and mediainfo support
//

Type.registerNamespace('EePlayer');

//
// optional URL parameters
//
EePlayer.UrlParam = {
    startTime   :   "startTime",    // specify start time for presentation on url in seconds as ...&start=5&...
    chapter     :   "chapter",      // start presentation at chapter # passed on url...&chapter=2&...
    loopCount   :   "loopCount",    // specify # of times to loop presentation on url as ...&loop=5&...  (-1 means forever)
    mediaUrl    :   "mediaUrl",     // overrides the video source passed into the script, plays this video instead
    volume      :   "volume",       // overrides starting volume
    muted       :   "muted",        // mute=true mutes volume at start
    duration    :   "duration",     // amount of time to play
    autoplay    :   "autoplay",    // auto start playing presentation (default = 1 - yes)
    mediainfo   :   "mediainfo"     // media info, URL to JScript file with function 'mediainfo' which returns a JSON array (see docs)
};


EePlayer.Player = function EePlayer$Player(domElement) {
    EePlayer.Player.initializeBase(this, [domElement]);
    this._fInitialized=false;
}

    function EePlayer$Player$initialize() {
        EePlayer.Player.callBaseMethod(this, 'initialize');

        // listen to URL parameters
        this.set_autoPlay( $getArgument(EePlayer.UrlParam.autoplay, this.get_autoPlay().toString()) === "true" );
        this.set_mediaUrl( $getArgument(EePlayer.UrlParam.mediaUrl, this.get_mediaUrl() ) );
        this.set_muted( $getArgument(EePlayer.UrlParam.muted, this.get_muted().toString() ) === "true" );
        this.set_volume( parseFloat($getArgument(EePlayer.UrlParam.volume, this.get_volume() )) );
        this.set_timeIndex( parseFloat($getArgument(EePlayer.UrlParam.startTime, this.get_timeIndex())) );
        this.set_mediainfo( $getArgument(EePlayer.UrlParam.mediainfo, this.get_mediainfo()) );
        var chapterArg = $getArgument(EePlayer.UrlParam.chapter);
        if (chapterArg!=="") {
            this.set_currentChapter(parseInt(chapterArg));
        }

        if (this.get_mediainfo()!=="")
            this._initMediainfo();

        this._fInitialized=true;
    }




    function EePlayer$Player$set_mediainfo(mediainfo) {
        this._mediainfo = mediainfo;
        if (this._fInitialized)
            this._initMediainfo();
    }

    function EePlayer$Player$_initMediainfo() {
        // Load mediainfo from URL or is this a mediainfo JSON array or a function that returns
        if (typeof(this._mediainfo)==="string") {
            var req = new Sys.Net.WebRequest();
            req.set_url(this._mediainfo);
            req.add_completed(Function.createDelegate(this, this._loadedMediainfo));
            var executor = new Sys.Net.XMLHttpExecutor();
            req.set_executor(executor);
            executor.executeRequest();
            var started = executor.get_started();
        }
        else if (typeof(this._mediainfo)==="function") {
            this.set_chapters( this._mediainfo().chapters );
            this.set_placeholderImage( this._mediainfo().placeholderImage );
            this.set_mediaUrl( this._mediainfo().mediaUrl );
        }
        else if (this._mediainfo.mediaUrl!=null) {
            this.set_chapters( this._mediainfo.chapters );
            this.set_placeholderImage( this._mediainfo.placeholderImage );
            this.set_mediaUrl( this._mediainfo.mediaUrl );
        }
        else {
            throw Error.invalidOperation("unknown type for mediainfo");
        }
    }

    function EePlayer$Player$_loadedMediainfo(executor, eventArgs) {
        if (executor.get_statusText()==="OK") {
            try {
                eval("("+executor.get_responseData()+")");
                var mediainfoJSON = mediainfo(); // call to your provided function...
                this.set_chapters( mediainfoJSON.chapters );
                this.set_placeholderImage( mediainfoJSON.placeholderImage );
                this.set_mediaUrl( mediainfoJSON.mediaUrl );
            } catch (e) {
                throw Error.invalidOperation("problem with mediainfo");
            }
        }
    }


    function EePlayer$Player$set_timeIndex(value) {
	    // check for skipping past end of file and raise media ended
        if(this._mediaElement && this._canSeek && value>this._naturalduration ) {
		this._raiseEvent("mediaEnded", Sys.EventArgs.Empty);
	}
	else {
		EePlayer.Player.callBaseMethod(this, 'set_timeIndex', [value]);
	}
    }
EePlayer.Player.prototype =  {
    initialize: EePlayer$Player$initialize,

    get_mediainfo: function () {
        return this._mediainfo;
    },
    set_mediainfo: EePlayer$Player$set_mediainfo,

    _initMediainfo: EePlayer$Player$_initMediainfo,

    _loadedMediainfo: EePlayer$Player$_loadedMediainfo,


    set_timeIndex: EePlayer$Player$set_timeIndex
}
EePlayer.Player._playerCount = 0;
EePlayer.Player._getUniqueName = function EePlayer$Player$_getUniqueName(baseName) {
    return baseName + EePlayer.Player._playerCount++;
}
EePlayer.Player.registerClass('EePlayer.Player', Ee.UI.Xaml.Media.Player);



function $getArgument(strArg, defVal) {
   var urlArgs=window.location.search.substring(1);
   var vals = urlArgs.split("&");
   var strArgLower = strArg.toLowerCase();
   for (var i=0;i<vals.length;i++) {
        var nvPair = vals[i].split("=");
        if (nvPair[0].toLowerCase() === strArgLower) {
            return unescape(nvPair[1]);
        }
   }
   if (typeof(defVal)!=='undefined') {
        return defVal;
   }
   return "";
}


